% GOAT_Environment initiation function for working in thew GOAT environment
% Copyright (C) Ori Adam, Apr.2013
% compatible with version 2013i or later
% ProjectPath specifies a path to be added where project specific *.m file can be placed
%
% see also, GOAT, GOAT_AutoDownload, GOAT_MyDefaults

function G = GOAT_Environment(ProjectPath)
G.EnvironmentFlag = 1 ;
G.GOAT_Directory = fileparts(which('GOAT.m')) ; 
if nargin == 1 && ~strcmpi(ProjectPath,'enter_project_path')
   try
       addpath(genpath(ProjectPath))     ;
   catch
       disp(['could not set project path: ',ProjectPath]) ; 
   end
end
G.AutoPilot.Mode = 'Off' ;
G = GOAT_Defaults(G)             ; % Set defaults
G.Settings.WaitbarCutoff = 1.e10 ; % no progress bar
G.Plotting.GUI_PlotFlag = 0      ; % plots are executed on clear figures with no GUI features
try
G = orderfields(G) ; 
end
