% GOAT_VersionUpdate  GOAT version update code.
% copyright (C) Ori Adam, Jan.2014
% This script updates appropriate paths shortcuts
% Existing Virtual Fields and the MyDefaults.m file are not replaced.
%
Quest = sprintf(['This application downloads the latest GOAT version from goat-geo.org', ...
'\nand automatically updates relevant paths and files.', ...
'\nVirtual field function, Scripts and the MyDefaults.m file are not replaced.', ...
'\nMake sure all files are saved before continuing.']) ;
button = questdlg(Quest,'Auto Update','Continue','Cancel','Cancel') ;

if strcmp(button,'Cancel')
disp 'update cancelled.'
else

 LatestVersion = '2015F23' ; 

try
LatestVersionFlag = strcmp(LatestVersion,ThisVersion) ;
catch
LatestVersionFlag = 0 ;
end

if LatestVersionFlag
Quest = sprintf(['You seem to have the latest version.', ...
'\nProceed anyway?']) ;
button = questdlg(Quest,'Auto Update','Continue','Cancel','Cancel') ;

buttonflag =  strcmp(button,'Cancel') ;
else
buttonflag = 0 ;
end
if buttonflag
disp 'update cancelled.'
else
cdPath = fileparts(cd) ;
disp 'Downloading latest GOAT version . . .'
filenames = unzip('http://www.oriadam.info/goat/GOAT.zip',fullfile(cdPath,'Downloads')) ;

%% Update GOAT folders
%cdPath = fullfile(fileparts(cd),'Downloads','temp','GOAT') ; % for testing

FoldersToUpdate = {'Code','Scripts','Documentation','Installation',fullfile('MyScripts','ExampleCode')} ;
for j = 1:length(FoldersToUpdate)
UpdateFolder = FoldersToUpdate{j} ;
disp(['Updating ',UpdateFolder,' . . .']) ;
root_dir = fullfile(cdPath,UpdateFolder) ;
for i = 1:length(filenames)
if regexp(filenames{i},fullfile('GOAT',UpdateFolder))
[Idx1 , Idx2] = regexp(filenames{i},fullfile('GOAT',UpdateFolder)) ;
File = filenames{i}(Idx2+1:end) ;
disp(['copying  ',filenames{i},'  to   ',fullfile(root_dir,File)])
if exist(fullfile(root_dir,File),'file')
try
delete(fullfile(root_dir,File)) ;
catch
disp(['could not delete ',fullfile(root_dir,File)]) ;
end
end
if ~exist(fileparts(fullfile(root_dir,File)),'dir')
mkdir(fileparts(fullfile(root_dir,File))) ;
end
copyfile(filenames{i},fullfile(root_dir,File)) ;
end
end
end

%% Updating MyScripts
MyScriptsToUpdate = {'GOAT_MyDefaults.m','GOAT_MySets.m'} ;
UpdateFolder = fullfile('MyScripts') ;
disp(['Updating ',UpdateFolder,' . . .']) ;
root_dir = fullfile(cdPath,UpdateFolder) ;
for i = 1:length(MyScriptsToUpdate)
fi = find(~cellfun(@isempty,regexp(filenames,MyScriptsToUpdate{i}))) ;
if ~exist(fullfile(root_dir,MyScriptsToUpdate{i}),'file') ;
disp(['copying  ',filenames{fi},'  to   ',fullfile(root_dir,MyScriptsToUpdate{i})])
if ~exist(fileparts(fullfile(root_dir,MyScriptsToUpdate{i})),'dir')
mkdir(fileparts(root_dir)) ;
end
copyfile(filenames{fi},fullfile(root_dir,MyScriptsToUpdate{i})) ;
end
end

%% Updating Virtual Fields
UpdateFolder = fullfile('MyScripts','MyVirtualFields') ;
disp(['Updating ',UpdateFolder,' . . .']) ;
root_dir = fullfile(cdPath,UpdateFolder) ;
for i = 1:length(filenames)
if regexp(filenames{i},fullfile('GOAT',UpdateFolder))
[Idx1 , Idx2] = regexp(filenames{i},fullfile('GOAT',UpdateFolder)) ;
File = filenames{i}(Idx2+1:end) ;
if ~exist(fullfile(root_dir,File),'file') ;
disp(['copying  ',filenames{i},'  to   ',fullfile(root_dir,File)])
if ~exist(fileparts(fullfile(root_dir,File)),'dir')
mkdir(fileparts(fullfile(root_dir,File))) ;
end
copyfile(filenames{i},fullfile(root_dir,File)) ;
end
end
end

%% Reset Paths
addpath(genpath(fullfile(cdPath,'Code')))     ;
addpath(genpath(fullfile(cdPath,'Scripts')))  ;
addpath(genpath(fullfile(cdPath,'MyScripts')))  ;
savepath ;
rehash ;

disp '  '
disp 'cleaning up . . .'
rmdir(fullfile(cdPath,'Downloads','GOAT'),'s') ;
disp '  '
try
soundsc(G.Error.Sound,G.Error.SoundFs) ;
end
disp(['Update to version ',LatestVersion,' Completed.'])

end
end
