% GOAT_CMIP5_Dataset2Clim
% Calculate climatology for all fields of r1i1p1 realizations of a certain
% CMIP5 experiment or Model output
%
% see also, GOAT_Dataset_Clim

G = GOAT_Environment ;

%Models = { ...  'CanESM2','bcc-csm1-1','CCSM4','CMCC-CESM','CMCC-CM','CMCC-CMS','CNRM-CM5','COSMOS-ASO','FGOALS-g2','FGOALS-s2','GFDL-CM3',
%                'GISS-E2-H-CC','GISS-E2-R-CC','HadGEM2-CC','HadGEM2-ES','IPSL-CM5A-LR','MPI-ESM-MR','MPI-ESM-P','MRI-CGCM3'
%Models = {'MPI-ESM-MR','MPI-ESM-P','MRI-CGCM3'} ;
RootFolder = '/Volumes/data3/CMIP5_LINK/piControl/' ; % Example
%RootFolder = uigetdir ; % alternative way of assigning a root experiment GOAT LINK or MAT folder
Folders = GOAT_FileFolderTrees(RootFolder) ;
%for M = 1:length(Models)
    Folders = GOAT_FileFolderTrees([RootFolder,Models{M}]) ;
    r1Idx = strcmp('r1i1p1',Folders(:,2)) ;
    Links2Clim = fullfile(RootFolder,Folders(r1Idx,1),Folders(r1Idx,2)) ;
    %Links2Clim = fullfile(RootFolder,Models{M},Folders(r1Idx,1),Folders(r1Idx,2)) ;
    for i = 1:length(Links2Clim)
        LINK = Links2Clim{i} ;
        %status = GOAT_Dataset_Clim(LINK,G,'OutputFolder',regexprep(LINK,'_LINK','_CLIM'),'FieldsToInclude',{'BoerBeta','pr','ua','va','zg','hus','ta','ps'},'calendarstoinclude','Monthly') ;     % Create a Mirror CMIP5_Clim folder
        try
        %status = GOAT_Dataset_Clim(LINK,G,'OutputFolder',regexprep(LINK,'_LINK','_CLIM'),'FieldsToInclude',{'hfls','hfss','rsds','rsus','rsns','rlds','rlus','rsns'},'calendarstoinclude','Monthly') ;     % Create a Mirror CMIP5_Clim folder
        status = GOAT_Dataset_Clim(LINK,G,'OutputFolder',regexprep(LINK,'_LINK','_CLIM'),'FieldsToInclude',{'wap','tas'},'calendarstoinclude','Monthly') ;     % Create a Mirror CMIP5_Clim folder
        %status = GOAT_Dataset_Clim(LINK,G,'OutputFolder',regexprep(LINK,'_LINK','_CLIM'),'FieldsToInclude',{'BoerBeta','pr','ua','va','zg','hus','ta','ps'},'calendarstoinclude','Monthly','year1',4000,'year2',4500) ;     % Create a Mirror CMIP5_Clim folder
        end
    end
%end
disp 'Converting all datasets to Clim for the root:'
disp(RootFolder)
disp 'Complete !'