% GOAT_CMIP5_filter_wget_fields  specify which fields to leave in a wget file generated by ESGF
% syntax: 
% >>   RevisedFileAddress = GOAT_CMIP5_filter_wget_fields(Original_wgetfile,FieldsToInclude,outputaddress)
% or
% >>   RevisedFileAddress = GOAT_CMIP5_filter_wget_fields(Original_wgetfile,FieldsToInclude) ; % RevisedFileAddress = 'Originalwgetfile_filtered'
% example:
% >>   RevisedFileAddress = GOAT_CMIP5_filter_wget_fields('wgetfile.sh',{'ta','tas'}) ; % RevisedFileAddress = 'wgetfile_filtered.sh'



function FileAddress = GOAT_CMIP5_filter_wget_fields(wgetfile,FieldsToInclude,outputaddress)
%%

f = fopen(wgetfile,'r');  % Open text file
InputText = textscan(f,'%s',20000,'delimiter','\n');
fclose(f) ;
InputText = InputText{1}  ;
linestokeep = ones(length(InputText),1) ;
%
for j = 1:length(FieldsToInclude)
    FieldsToInclude(j) = {['''',FieldsToInclude{j},'_']} ;
end
%
FilesToDownloadFlag = 0 ;
for i = 1:length(InputText)
    if strncmpi(InputText{i},'download_files=',15)
        FilesToDownloadFlag = 1 ;
        continue
    end
    if strncmpi(InputText{i},'EOF--dataset.file',17)
        %FilesToDownloadFlag = 0 ;
        break
    end
    
    if FilesToDownloadFlag
        KeepFile = 0 ; 
        for j = 1:length(FieldsToInclude)
            if strncmp(InputText{i},FieldsToInclude{j},length(FieldsToInclude{j})) ;
               KeepFile = 1 ;  
            end
        end
        linestokeep(i) = KeepFile ;
    end
end
OutputText = InputText(linestokeep==1) ; 

if nargin > 2
 FileAddress = outputaddress ; 
else
 [Path,Name,Ext] = fileparts(wgetfile) ; 
 FileAddress = fullfile(Path,[Name,'_filtered',Ext]) ; 
end
GOAT_cell2txt(FileAddress,OutputText) ;
