DataSet_LINK    = '/Users/oradam/Documents/MATLAB/GOAT/Data_LINK/20CR_LINK/' ;
DataSet_Install = '/Volumes/data3/GOAT/Data/R20C'                                   ;
Calendar  = 'Daily'                                                                  ;
Fields         = {'tas','ta','ua','va','hus','ps','pr','pr_wtr_eatm'} ;
% Span
year1  = 1871 ; % yyyy
month1 = 1    ; % 1:12
day1   = 1    ; % 1:31
hour1  = 0    ; % 0:3:21
year2  = 2011 ;
month2 = 12    ;
day2   = 31    ;
hour2  = 18    ;
% Initiate GOAT and set: Dataset, Field and Calendar
Ntry = 10 ; Nt = 1 ; 
G = GOAT_Environment('enter_project_path') ; % Initiate GOAT Environment
for f = 1:length(Fields)
    Field = Fields{f} ;
    switch Field
        case {'tas','pr'}
            Type = 'Monolevel_Gaussian' ;
        case {'ps','pr_wtr_eatm'}
            Type = 'Monolevel' ;
        case {'hus','ua','va','zg','ta','wap','hur'}
            Type = 'Isobaric' ;
    end
    G = GOAT_Initialize_Dataset(G,fullfile(DataSet_LINK,Type),Calendar) ; % Go through contents of Data folder and Calendar. Link existing fields, temporal span, etc.
    G = GOAT_Initialize_Field(G,Field)        ; % get spatial and temporal dimensions of field, display settings, topography, and file addresses. Link if necessary
    G.Limits.Default.Day2same   = 0 ; % 1/0 Set Date 2 same as Date 1
    G.Limits.Default.Sequential = 1 ; % 1/0 Sequential or Seasonal averaging Flag
    G.Limits.Default.ClimatologyContinuous = 0 ; % present seasonal data sequentially in Hovmoller plots
    G.Limits.Default.Anom  = 0      ; % display anomalies in Hovmoller plots
    G.Limits.S1 = GOAT_getSerial(year1,month1,day1,hour1,G.TimeFieldVirtual,G.Limits.Year0) ;
    if G.Limits.Default.Day2same && G.Limits.Default.Sequential
        G.Limits.S2 = G.Limits.S1 ;
    else
        G.Limits.S2 = GOAT_getSerial(year2,month2,day2,hour2,G.TimeFieldVirtual,G.Limits.Year0) ;
    end
    % Install Linked Data
    G.ProjectionType = 10 ; %
    G.ALP.ExportAddress  = fullfile(DataSet_Install,Calendar,Field) ; %
    G.ALP.Calendar       = Calendar ; % Calendar
    G.ALP.OverWriteFlag  = 1 ; % when checked, data will NOT be overwritten
    if strcmp(Field,'zg')
        G.ALP.BoerBetaFlag   = 1 ; % create BoerBeta function
    else
        G.ALP.BoerBetaFlag   = 0 ; % create BoerBeta function
    end
    G.ALP.SaveSingle     = 1 ; % save data as single precision
    if G.ALP.OverWriteFlag
    % Try Ntry times. OPeNDAP sometimes fails
    while Nt <=Ntry
        try
            G = GOAT_ALP_Install(G) ; % Install as MAT archive format from OPeNDAP server or nc file
            Nt = Ntry + 1 ; 
        catch
            disp(['Try ',int2str(Nt),'/',int2str(Ntry),' failed. Retrying . . .'])
            Nt = Nt + 1 ;
        end
    end
    Nt = 1 ;
    else
        G = GOAT_ALP_Install(G) ; % Install as MAT archive format from OPeNDAP server or nc file
    end
end

disp 'GOAT_20CR_Installation Complete !'