% GOAT_ALP_NCEP_evalStr_load is called in Rotating LINK NCEP archives and is used to
% update the OPeNDAP URLs, start start, and count vectors in the field Attributes

function Attributes = GOAT_ALP_NCEP_evalStr_load(Attributes,Identifier)
if nargin == 1
    Identifier = 0 ;
end
months_strings = {'jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec'} ;
switch Identifier
    case 0
        
    otherwise
        Col1 = Attributes{1,1} ;
        opendap_address = Col1{end,1} ;
        a = ncinfo(opendap_address,'time') ;
        Minimum_Time = a.Attributes(find(strcmp({a.Attributes.Name},'minimum'))).Value ;
        First_Hour  = str2double(Minimum_Time(1:2)) ;
        First_Day   = str2double(Minimum_Time(4:5)) ;
        First_Month = find(strcmpi(Minimum_Time(6:8),months_strings)) ;
        First_Year  = str2double(Minimum_Time(9:end)) ;
        Maximum_Time = a.Attributes(find(strcmp({a.Attributes.Name},'maximum'))).Value ;
        Last_Year   = str2double(Maximum_Time(9:end)) ;
        Last_Hour  = str2double(Maximum_Time(1:2)) ;
        Last_Day   = str2double(Maximum_Time(4:5)) ;
        Last_Month = find(strcmpi(Maximum_Time(6:8),months_strings)) ;
        
        Attributes(end,2) = {[First_Year Last_Year]} ;
        q0 = GOAT_getSerial(First_Year,First_Month,First_Day,First_Hour,Attributes{end,4},First_Year) - 1  ;
        qc = GOAT_getSerial(Last_Year,Last_Month,Last_Day,Last_Hour,Attributes{end,4},First_Year) - q0  ;
        % shift first date for all unique value columns
        if q0 > 0
            qIdx = 2 ;
        else
            qIdx = 1 ;
        end
        for j = [1 2 4 5]
            Colj = Attributes{1,j} ;
            Col = cell(qIdx,2) ;
            if q0
                Col(1,1) = {[]} ;
                Col(1,2) = {q0} ;
            end
            Col(qIdx,1) = Colj(end,1) ;
            Col(qIdx,2) = {qc} ;
            Attributes(1,j) = {Col} ;
        end
        % adjust eval string for start
        if q0
            Col(1,1) = {[]} ;
            Col(1,2) = {q0} ;
        end
        Colj = Attributes{1,3} ;
        evalStr = Colj{end,1} ;
        [Beg , End] = regexp(evalStr,'ones(') ;
        ComaIdx = regexp(evalStr(End+1:end),',','once') ;
        Old_qc = evalStr(End+1:End+ComaIdx-1) ;
        % assuming qc is not a 1 digit number
        evalstr = regexprep(evalStr,Old_qc,int2str(qc)) ;
        Col(qIdx,1) = {evalstr} ;
        Col(qIdx,2) = {'eval'} ;
        Attributes(1,3) = {Col} ;
end