% LINK to TRMM OPeNDAP datasets
G = GOAT_Environment ; 
ReferenceURL = 'http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/YYYY/DDD/3B31.YYYYmm01.7.HDF.Z.ncml' ; 
%http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1997/335/3B31.19971201.7.HDF.Z.ncml
%http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1998/001/3B31.19980101.7.HDF.Z.ncml
%http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1998/152/3B31.19980601.7.HDF.Z.ncml
%http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1999/001/3B31.19990101.7.HDF.Z.ncml
%http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/2000/001/3B31.20000101.7.HDF.Z.ncml
%http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/2006/152/3B31.20060601.7.HDF.Z.ncml
Data_LINK = '/Users/oradam/Documents/MATLAB/GOAT/Data_LINK' ; 
DataSetName = 'TRMM_3B31' ; 
year1 = 1997 ; year2 = 2014 ;
G = GOAT_Produce_DefaultAddress(G,year1,year2,'Monthly','dap') ;
 
ac = ncinfo('http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1997/335/3B31.19971201.7.HDF.Z.ncml') ; 
%for i = 1:length(ac.Variables) ; 
%    disp(ac.Variables(i).Name) ; 
%end
infostr = sprintf(['TRMM Combined Precipitation Radar (PR) and TRMM Microwave Imager (TMI) Gridded Rainfall Product (TRMM Product 3B31)', ...
    '\nThe TRMM Microwave Imager (TMI) is a nine-channel passive microwave radiometer which builds on the heritage of the Special Sensor Microwave/Imager (SSM/I) instrument.', ... 
    '\nIt is flown aboard the Defense Meteorological Satellite Program (DMSP) platforms.', ...
    '\nThe TRMM Precipitation Radar (PR), the first of its kind in space, is an electronically scanning radar, operating at 13.8 GHz ', ...
    '\nthat measures the 3-D rainfall distribution over both land and ocean, and defines the layer depth of the precipitation.', ...
    '\nThe TRMM 3B31 Monthly 0.5 deg. x 0.5 deg. Combined Rainfall product, contains Rain rate, rain water, snow and graupel at 28 levels', ...
    '\nfor a latitude band from 40 degree N to 40 degree S. It is derived from the TRMM combined algorithm (2B31),', ...
    '\nwhich combines data from the TMI and PR to produce the best rain estimate for TRMM.']) ; 
mkdir(fullfile(Data_LINK,DataSetName,'Monthly')) ; 
save(fullfile(Data_LINK,DataSetName,'Monthly','info.mat'),'infostr') ;
VerticalOrdinate = 'Height (m)' ;
lon = ncread('http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1997/335/3B31.19971201.7.HDF.Z.ncml','nlon')  ;
lat = ncread('http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1997/335/3B31.19971201.7.HDF.Z.ncml','nlat')  ;
nlayer = ncread('http://disc2.nascom.nasa.gov:80/opendap/ncml/TRMM_L3/TRMM_3B31/1997/335/3B31.19971201.7.HDF.Z.ncml','nlayer')  ;
lonlabel = 'Longitude' ; 
latlabel = 'Latitude'  ;
Plabel   = 'Height'    ;
FieldsToLink = {'surfacePrecipTMI','convectPrecipTMI','rainWaterTMI','snowTMI','graupelTMI','surfacePrecipCOMB','rainWaterCOMB','snowCOMB','graupelCOMB'} ; 
for i = 1:length(FieldsToLink)
    disp(['linking ',FieldsToLink{i},'(',int2str(i),'/',int2str(length(FieldsToLink)),') . . .']) ;
    Idx = find(strcmp(FieldsToLink{i},{ac.Variables(:).Name})) ; 
        if length(ac.Variables(Idx).Size) == 3
            P = nlayer*1000 ;
            start = [1 1 1] ; 
            count = [inf inf inf] ; 
            DimNames = [ac.Variables(Idx).Dimensions(1).Name,ac.Variables(Idx).Dimensions(2).Name,ac.Variables(Idx).Dimensions(3).Name] ; 
        else
            P = 0 ; 
            start = [1 1] ; 
            count = [inf inf] ; 
            DimNames = [ac.Variables(Idx).Dimensions(1).Name,ac.Variables(Idx).Dimensions(2).Name] ; 
        end
    Units = ac.Variables(Idx).Attributes(find(strcmpi('units',{ac.Variables(Idx).Attributes(:).Name}))).Value ; 
    switch DimNames
        case 'nlatnlon'
        Permute = {[2 1]}   ;
        case 'nlonnlayernlat'    
        Permute = {[1 3 2]}   ;
        case 'nlatnlonnlayer'
        Permute = {[2 1 3]}   ;
        case 'nlatnlayernlon'    
        Permute = {[3 1 2]}   ;
        case 'nlayernlonnlat'
        Permute = {[2 3 1]}   ;
        case 'nlayernlatnlon'
        Permute = {[3 2 1]}   ;
        otherwise
        Permute = {[]}   ;    
    end
    Defs.ReferenceSettingsField = 'pr' ; 
    switch FieldsToLink{i}
        case 'surfacePrecipTMI'
        FieldDescription = 'The monthly mean of the instantaneous precipitation at the surface for each grid (TRMM Microwave Imager).' ;  
        case 'convectPrecipTMI'
        FieldDescription = 'The monthly mean of the instantaneous convective precipitation at the surface for each grid (TRMM Microwave Imager).' ;    
        case 'rainWaterTMI'
        FieldDescription = sprintf('The monthly mean of the instantaneous rain (liquid portion of precipitation) at each vertical layer (TRMM Microwave Imager).') ; 
        case 'snowTMI'
        FieldDescription = 'The monthly mean of the snow liquid water content for each grid at each vertical layer (TRMM Microwave Imager).' ;        
        case 'graupelTMI'
        FieldDescription = 'The monthly mean of the graupel liquid water content for each grid at each vertical layer (TRMM Microwave Imager).' ;            
        case 'surfacePrecipCOMB'
        FieldDescription = 'Surface combined rain from TRMM Precipitation Radar and Microwave Imager accumulated in each grid box' ;
        case 'rainWaterCOMB'
        FieldDescription = 'Rain water content at each vertical layer from TRMM Precipitation Radar and Microwave Imager accumulated in each grid box' ; 
        case 'snowCOMB'
        FieldDescription = 'Snow water content at each vertical layer from TRMM Precipitation Radar and Microwave Imager accumulated in each grid box' ;     
        case 'graupelCOMB'    
        FieldDescription = 'Graupel water content at each vertical layer from TRMM Precipitation Radar and Microwave Imager accumulated in each grid box' ;     
    end 
    mkdir(fullfile(Data_LINK,DataSetName,'Monthly',FieldsToLink{i})) ; 
    save(fullfile(Data_LINK,DataSetName,'Monthly',FieldsToLink{i},'Dims.mat'),'P','Plabel','lon','lonlabel','lat','latlabel','Units','FieldDescription','VerticalOrdinate') ; 
    Addresses = G.Addresses.Default ;
    Attributes = cell(length(Addresses),8) ;
    % Attributes(i,1) = filename ;
    % Attributes(i,2) = varname  ;
    % Attributes(i,3) = start    ;
    % Attributes(i,4) = count    ;
    % Attributes(i,5) = factor   ;
    % Attributes(i,6) = permute   ;
    % Attributes(i,7) = reshape (add dimensions)   ;
    % Attributes(i,8) = NanLimits (set to nan if data < NanLimits(1) | data > NanLimits(2)). If length(NanLimits)==1, data < NanLimits = nan.
    % Assign Attributes to each date
    for k = 12:length(Addresses) - 1 ;
    Attributes(k,2) = FieldsToLink(i)  ;
    Attributes(k,3) = {start}  ;
    Attributes(k,4) = {count}  ;
    Attributes(k,5) = {1}  ;
    Attributes(k,6) = Permute  ;
    Attributes(k,8) = {-9999}  ;
    % set data address
    [year,month] = GOAT_serial2date(Addresses,k) ;
    Jd = GOAT_JulianDay(year,month,1) ; 
    URL = regexprep(ReferenceURL,'YYYY',int2str(year)) ; 
    URL = regexprep(URL,'DDD',num2str(Jd,'%03.0f')) ;
    URL = regexprep(URL,'mm',num2str(month,'%02.0f')) ;
    Attributes(k,1) = {URL}  ;
    end
    Attributes(end,1) = {'dap'} ; % 'mat' | 'ncf' | 'dap' | 'gb1' | 'gb2'
    Attributes(end,2) = {[year1 year2]} ;
    Attributes(end,3) = {Defs} ;
    Attributes(end,4) = {'Monthly'} ;
    Attributes = GOAT_ALP_CompressAttributes(Attributes) ; 
    save(fullfile(Data_LINK,DataSetName,'Monthly',FieldsToLink{i},'link_field.mat'),'Attributes') ;
end

%% Daily
G = GOAT_Environment ;
%                                                                       date 
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/1997/365/3B42_daily.1998.01.01.7.bin
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/1998/001/3B42_daily.1998.01.02.7.bin 
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/1999/365/3B42_daily.2000.01.01.7.bin Dec.31.1999
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/2001/001/3B42_daily.2001.01.02.7.bin
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/2001/365/3B42_daily.2002.01.01.7.bin
ReferenceURL = 'http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/yyyy/DDD/3B42_daily.YYYY.mm.dd.7.bin' ; 
Data_LINK = '/Users/oradam/Documents/MATLAB/GOAT/Data_LINK' ; 
DataSetName = 'TRMM_3B42' ; 
year1 = 1998 ; year2 = 2014 ;
G = GOAT_Produce_DefaultAddress(G,year1,year2,'Daily','dap') ;
 ac = ncinfo('http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/1998/001/3B42_daily.1998.01.02.7.bin') ; 
%for i = 1:length(ac.Variables) ; 
%    disp(ac.Variables(i).Name) ; 
%end
infostr = sprintf(['The purpose of the 3B42 algorithm is to produce TRMM-adjusted merged-infrared (IR) precipitation and root-mean-square (RMS) precipitation-error estimates. ', ...
    '\nThe algorithm consists of two separate steps:', ... 
    '\nIt is flown aboard the Defense Meteorological Satellite Program (DMSP) platforms.', ...
    '\nThe first step uses the TRMM VIRS and TMI orbit data (TRMM products 1B01 and 2A12) and the monthly TMI/TRMM Combined Instrument (TCI) calibration parameters (from TRMM product 3B31)', ...
    '\nto produce monthly IR calibration parameters.', ...
    '\nThe second step uses these derived monthly IR calibration parameters to adjust the merged-IR precipitation data,', ...
    '\nwhich consists of GMS, GOES-E, GOES-W, Meteosat-7, Meteosat-5, and NOAA-12 data.', ...
    '\nThe final gridded, adjusted merged-IR precipitation (mm/hr) and RMS precipitation-error estimates have a daily temporal resolution and a 0.25-degree by 0.25-degree spatial resolution. ']) ; 
    
mkdir(fullfile(Data_LINK,DataSetName,'Daily','pr')) ; 
save(fullfile(Data_LINK,DataSetName,'Daily','info.mat'),'infostr') ;
VerticalOrdinate = 'Height (m)' ;
lon = -180:0.25:180-0.25 ; 
lat = -50+0.125:0.25:50-0.125 ;
P = 0 ; 
lonlabel = 'Longitude' ; 
latlabel = 'Latitude'  ;
Plabel   = 'Surface'    ;
Units = 'mm/day' ; 
FieldDescription = 'Total Surface Precipitation' ; 
VerticalOrdinate = 'Height (m)' ; 
Defs.ReferenceSettingsField = 'pr' ; 
start = [1 1] ; 
count = [inf inf] ;
save(fullfile(Data_LINK,DataSetName,'Daily','pr','Dims.mat'),'P','Plabel','lon','lonlabel','lat','latlabel','Units','FieldDescription','VerticalOrdinate') ; 
Addresses = G.Addresses.Default ;
Attributes = cell(length(Addresses),8) ;
% Attributes(i,1) = filename ;
% Attributes(i,2) = varname  ;
% Attributes(i,3) = start    ;
% Attributes(i,4) = count    ;
% Attributes(i,5) = factor   ;
% Attributes(i,6) = permute   ;
% Attributes(i,7) = reshape (add dimensions)   ;
% Attributes(i,8) = NanLimits (set to nan if data < NanLimits(1) | data > NanLimits(2)). If length(NanLimits)==1, data < NanLimits = nan.
% Assign Attributes to each date
disp 'creating TRMM_3B42 attributes ... '
for k = 1:length(Addresses) - 1 ;
    Attributes(k,2) = {'data'}  ;
    Attributes(k,3) = {start}  ;
    Attributes(k,4) = {count}  ;
    Attributes(k,5) = {1}  ;
    Attributes(k,6) = {[]}  ;
    Attributes(k,8) = {-9999}  ;
    % set data address
    [year,month,day] = GOAT_serial2date(Addresses,k) ;
    Jd = GOAT_JulianDay(year,month,day) ;
    URL = regexprep(ReferenceURL,'YYYY',int2str(year)) ;
    URL = regexprep(URL,'mm',num2str(month,'%02.0f')) ;
    URL = regexprep(URL,'dd',num2str(day,'%02.0f')) ;
    if Jd > 1
    URL = regexprep(URL,'DDD',num2str(Jd-1,'%03.0f')) ;
    URL = regexprep(URL,'yyyy',num2str(year,'%03.0f')) ;
    else
       URL = regexprep(URL,'yyyy',num2str(year-1,'%03.0f')) ;  
       if GOAT_leapyear(year-1)
         URL = regexprep(URL,'DDD',num2str(366,'%03.0f')) ;
       else
         URL = regexprep(URL,'DDD',num2str(365,'%03.0f')) ;  
       end
    end
    Attributes(k,1) = {URL}  ;
end
Attributes(end,1) = {'dap'} ; % 'mat' | 'ncf' | 'dap' | 'gb1' | 'gb2'
Attributes(end,2) = {[year1 year2]} ;
Attributes(end,3) = {Defs} ;
Attributes(end,4) = {'Daily'} ;
Attributes = GOAT_ALP_CompressAttributes(Attributes) ; 
save(fullfile(Data_LINK,DataSetName,'Daily','pr','link_field.mat'),'Attributes') ;
disp 'TRMM_3B42 attributes ... Done.'

%% %% DailyX8   Cannot OPeNDAP HDF.Z = zipped files.
%
G = GOAT_Environment ;
%                                                                       date 
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3Hourly_3B42/1997/365/3B42.19980101.00.7.HDF.Z
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3Hourly_3B42/1998/003/3B42.19980103.03.7.HDF.Z
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3Hourly_3B42/1998/001/3B42.19980101.03.7.HDF.Z
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3Hourly_3B42/2003/001/3B42.20030101.03.7A.HDF.Z
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3Hourly_3B42/2000/011/3B42.20000111.09.7A.HDF.Z
%http://disc2.nascom.nasa.gov:80/opendap/TRMM_3B42/TRMM_3B42_daily/2001/365/3B42_daily.2002.01.01.7.bin
ReferenceURL = 'http://disc2.nascom.nasa.gov/daac-bin/OTF/HTTP_services.cgi?FILENAME=%2Fftp%2Fdata%2Fs4pa%2FTRMM_L3%2FTRMM_3B42%2Fyyyy%2Fddd%2F3B42.YYYYmmDD.HH.7.HDF.Z&LABEL=3B42.YYYYmmDD.HH.7.nc&SHORTNAME=TRMM_3B42&SERVICE=HDF_TO_NetCDF&VERSION=1.02' ; 
Data_LINK = '/Users/oradam/Documents/MATLAB/GOAT/Data_LINK' ; 
DataSetName = 'TRMM_3B42' ; 
year1 = 1998 ; year2 = 2014 ;
G = GOAT_Produce_DefaultAddress(G,year1,year2,'DailyX8','dnc') ;

infostr = sprintf(['The purpose of the 3B42 algorithm is to produce TRMM-adjusted merged-infrared (IR) precipitation and root-mean-square (RMS) precipitation-error estimates. ', ...
    '\nThe algorithm consists of two separate steps:', ... 
    '\nIt is flown aboard the Defense Meteorological Satellite Program (DMSP) platforms.', ...
    '\nThe first step uses the TRMM VIRS and TMI orbit data (TRMM products 1B01 and 2A12) and the monthly TMI/TRMM Combined Instrument (TCI) calibration parameters (from TRMM product 3B31)', ...
    '\nto produce monthly IR calibration parameters.', ...
    '\nThe second step uses these derived monthly IR calibration parameters to adjust the merged-IR precipitation data,', ...
    '\nwhich consists of GMS, GOES-E, GOES-W, Meteosat-7, Meteosat-5, and NOAA-12 data.', ...
    '\nThe final gridded, adjusted merged-IR precipitation (mm/hr) and RMS precipitation-error estimates have a daily temporal resolution and a 0.25-degree by 0.25-degree spatial resolution. ']) ; 
    
mkdir(fullfile(Data_LINK,DataSetName,'DailyX8','pr')) ; 
mkdir(fullfile(Data_LINK,DataSetName,'DailyX8','pr_err')) ; 
mkdir(fullfile(Data_LINK,DataSetName,'DailyX8','pr_mw')) ;
mkdir(fullfile(Data_LINK,DataSetName,'DailyX8','pr_ir')) ;
save(fullfile(Data_LINK,DataSetName,'DailyX8','info.mat'),'infostr') ;
VerticalOrdinate = 'Height (m)' ;
lon = -180:0.25:180-0.25 ; 
lat = -50+0.125:0.25:50-0.125 ;
P = 1 ; 
lonlabel = 'Longitude' ; 
latlabel = 'Latitude'  ;
Plabel   = 'Surface'    ;
Units = 'mm/hr' ; 
start = [1 1 1] ; 
count = [inf inf 1] ;
FieldDescription = 'Instantaneous precipitation (merged product estimate)' ; 
save(fullfile(Data_LINK,DataSetName,'DailyX8','pr','Dims.mat'),'P','Plabel','lon','lonlabel','lat','latlabel','Units','FieldDescription','VerticalOrdinate') ; 
FieldDescription = 'Instantaneous pre gauge-adjusted microwave precipitation estimate' ; 
save(fullfile(Data_LINK,DataSetName,'DailyX8','pr_mw','Dims.mat'),'P','Plabel','lon','lonlabel','lat','latlabel','Units','FieldDescription','VerticalOrdinate') ; 
FieldDescription = 'Instantaneous pre gauge-adjusted Infra-Red precipitation estimate' ; 
save(fullfile(Data_LINK,DataSetName,'DailyX8','pr_ir','Dims.mat'),'P','Plabel','lon','lonlabel','lat','latlabel','Units','FieldDescription','VerticalOrdinate') ; 
FieldDescription = 'Instantaneous precipitation error estimate' ; 
save(fullfile(Data_LINK,DataSetName,'DailyX8','pr_err','Dims.mat'),'P','Plabel','lon','lonlabel','lat','latlabel','Units','FieldDescription','VerticalOrdinate') ; 
Addresses = G.Addresses.Default ;
Defs.ReferenceSettingsField = 'pr' ; 
% Attributes(i,1) = filename ;
% Attributes(i,2) = varname  ;
% Attributes(i,3) = start    ;
% Attributes(i,4) = count    ;
% Attributes(i,5) = factor   ;
% Attributes(i,6) = permute   ;
% Attributes(i,7) = reshape (add dimensions)   ;
% Attributes(i,8) = NanValue (data(data=NanValue) = nan)   ;
% Assign Attributes to each date

for v = 1:4
Attributes = cell(length(Addresses),8) ;    
switch v
    case 1
        variable = 'pcp' ; 
        savename = 'pr'  ;
    case 2
        variable = 'err' ;
        savename = 'pr_err'  ;
    case 3 
        variable = 'hqp' ;
        savename = 'pr_mw'  ;
    case 4
        variable = 'irp' ; 
        savename = 'pr_ir'  ;
end
disp(['creating TRMM_3B42 ',savename,' attributes ... '])
for k = 1:length(Addresses) - 1 ;
    Attributes(k,2) = {variable}  ;
    Attributes(k,3) = {start}  ;
    Attributes(k,4) = {count}  ;
    Attributes(k,5) = {1}  ;
    Attributes(k,6) = {[]}  ;
    Attributes(k,8) = {-9999}  ;
    % set data address
    [year,month,day,hour] = GOAT_serial2date(Addresses,k) ;
    Jd = GOAT_JulianDay(year,month,day) ;
    if Jd == 1 && hour == 0
        URL = regexprep(ReferenceURL, 'yyyy', int2str(year-1)) ;
        if GOAT_leapyear(year-1)
            URL = regexprep(URL, 'ddd', int2str(366)) ;
        else
            URL = regexprep(URL, 'ddd', int2str(365)) ;
        end
    else
        URL = regexprep(ReferenceURL, 'yyyy', int2str(year)) ;
        if hour == 0
            URL = regexprep(URL, 'ddd', num2str(Jd-1,'%03.0f')) ;
        else
            URL = regexprep(URL, 'ddd', num2str(Jd,'%03.0f')) ;
        end
    end
    URL = regexprep(URL, 'YYYY', int2str(year)) ;
    URL = regexprep(URL, 'mm', num2str(month,'%02.0f')) ;
    URL = regexprep(URL, 'DD', num2str(day,'%02.0f')) ;
    URL = regexprep(URL, 'HH', num2str(hour,'%02.0f')) ;
    if year>=2000 && year <=2010
       URL = regexprep(URL, '.7.', '.7A.') ;
    end
    
    Attributes(k,1) = {URL}  ;
end
Attributes(end,1) = {'dnc'} ; % 'mat' | 'ncf' | 'dap' | 'gb1' | 'gb2'
Attributes(end,2) = {[year1 year2]} ;
Attributes(end,3) = {Defs} ;
Attributes(end,4) = {'DailyX8'} ;
Attributes = GOAT_ALP_CompressAttributes(Attributes) ; 
save(fullfile(Data_LINK,DataSetName,'DailyX8',savename,'link_field.mat'),'Attributes') ;
end
disp 'TRMM_3B42 attributes ... Done.'
%}