% save Julian and gregorian string matrices that can be used as blocks for creating DefaultAddress vectors

% Julian Addresses
max_days_per_year = 600 ;
JulianAddressesX24 = cell(max_days_per_year*24,1) ;
q = 0 ;
for d = 1:max_days_per_year
    for h = 1:24
        q = q + 1 ;
        JulianAddressesX24(q,1) = {[num2str(d*100 + h-1),'.mat']} ;
    end
end



% Gregorian Addresses
GregorianAddressesX24 = cell(365*24,1) ;
q = 0 ; 
for m = 1:12
    switch m
        case {1,3,5,7,8,10,12}
          dd =  31 ;
        case 2 
          dd = 28 ; 
        case {4,6,9,11} 
          dd = 30 ; 
    end
    for d = 1:dd
        for h = 1:24
        q = q + 1 ; 
        GregorianAddressesX24(q,1) = {[int2str(m*10000 + d*100 + h-1),'.mat']} ; 
        end       
    end
end

GregorianAddressesX24leap = cell(366*24,1) ;
q = 0 ; 
for m = 1:12
    switch m
        case {1,3,5,7,8,10,12}
          dd =  31 ;
        case 2 
          dd = 29 ; 
        case {4,6,9,11} 
          dd = 30 ; 
    end
    for d = 1:dd
        for h = 1:24
        q = q + 1 ; 
        GregorianAddressesX24leap(q,1) = {[int2str(m*10000 + d*100 + h-1),'.mat']} ; 
        end       
    end
end


GregorianAddressesMonth = cell(12,1) ;
for m = 1:12
GregorianAddressesMonth(m,1) = {[int2str(m*10000),'.mat']} ; 
end

save('AddressRepmats.mat','GregorianAddressesMonth','GregorianAddressesX24leap','GregorianAddressesX24','JulianAddressesX24')

