% GOAT_ALP_ERA20C_LINK link code for ERA-20C DailyX8, DailyX4 , Daily  and  Monthly by using perl scripts to send batch jobs to the MARS API server


G = GOAT_Environment ;
Data_ALP = fullfile(fileparts(fileparts(which('GOAT.m'))),'Data_LINK') ; % LINK Data folder
% Monthly LINK first
% Units and Name Conversion Array
CV = cell(1,8) ; qV = 1 ;
% A = flag for Forecast or Analysis: 0) both Forecast and Analysis 1) only analysis 2) only Forecast
% pl = flag for surface (sfc) or Pressure levels (pl)
[CV(qV,:)] = deal([{'name'}    ,{'std_name'},{'Fctr'},{'Units'}     ,{'param'},{'A'},{'pl'} ,{'Description'}])                                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'u10'}     ,{'ua10m'}   ,{1}     ,{'m/s'}       ,{'165.128'},{1},{'sfc'},{'10 meter eastward wind component'}])               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'v10'}     ,{'va10m'}   ,{1}     ,{'m/s'}       ,{'166.128'},{1},{'sfc'},{'10 meter northward wind component'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'si10'}    ,{'wspd10m'} ,{1}     ,{'m/s'}       ,{'207.128'},{1},{'sfc'},{'10 meter wind speed'}])                            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'d2m'}     ,{'d2m'}     ,{1}     ,{'K'}         ,{'168.128'},{1},{'sfc'},{'2 meter dew point temperature'}])                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'t2m'}     ,{'at2m'}    ,{1}     ,{'K'}         ,{'167.128'},{1},{'sfc'},{'2 meter temeprature'}])                            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'al'}      ,{'albedo'}  ,{1}     ,{'1'}         ,{'174.128'},{1},{'sfc'},{'Surface albedo'}])                                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'blh'}     ,{'blh'}     ,{1}     ,{'m'}         ,{'159.128'},{2},{'sfc'},{'Bounday Layer Height'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'chnk'}    ,{'charnock'},{1}     ,{'None'}      ,{'148.128'},{1},{'sfc'},{'Charnock'}])                                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'cape'}    ,{'cape'}    ,{1}     ,{'J/kg'}      ,{'59.128'} ,{2},{'sfc'},{'Convective available potential energy'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'fal'}     ,{'albdeo'}  ,{1}     ,{'1'}         ,{'243.128'},{2},{'sfc'},{'Forecast Albedo'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'flsr'}    ,{'lsrh'}    ,{1}     ,{'None'}      ,{'245.128'},{2},{'sfc'},{'Forecast logarithm of surface roughness for heat'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'fsr'}     ,{'sr'}      ,{1}     ,{'m'}         ,{'244.128'},{2},{'sfc'},{'Forecast surface roughness length'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'hcc'}     ,{'hcc'}     ,{1}     ,{'1'}         ,{'188.128'},{1},{'sfc'},{'High cloud cover'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl1'}   ,{'istl1'}   ,{1}     ,{'K'}         ,{'35.128'} ,{1},{'sfc'},{'Ice temperature layer 1'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl2'}   ,{'istl2'}   ,{1}     ,{'K'}         ,{'36.128'} ,{1},{'sfc'},{'Ice temperature layer 2'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl3'}   ,{'istl3'}   ,{1}     ,{'K'}         ,{'37.128'} ,{1},{'sfc'},{'Ice temperature layer 3'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl4'}   ,{'istl4'}   ,{1}     ,{'K'}         ,{'38.128'} ,{1},{'sfc'},{'Ice temperature layer 4'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'iews'}    ,{'iews'}    ,{1}     ,{'N/m^2'}     ,{'229.128'},{2},{'sfc'},{'Instantaneous eastward turbulent surface stress'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'ie'}      ,{'ie'}      ,{1}     ,{'Kg/m^2/s'}  ,{'232.128'},{2},{'sfc'},{'Instantaneous moisture flux'}])                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'inss'}    ,{'inss'}    ,{1}     ,{'N/m^2'}     ,{'230.128'},{2},{'sfc'},{'Instantaneous northward turbulent surface stress'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'ishf'}    ,{'ishf'}    ,{1}     ,{'W/m^2'}     ,{'231.128'},{2},{'sfc'},{'Instantaneous surface sensible heat flux'}])       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lsrh'}    ,{'lsrh'}    ,{1}     ,{'None'}      ,{'234.128'},{1},{'sfc'},{'Logarithm of surface roughness for heat'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lcc'}     ,{'lcc'}     ,{1}     ,{'1'}         ,{'186.128'},{1},{'sfc'},{'Low cloud cover'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'msl'}     ,{'psl'}     ,{1}     ,{'Pa'}        ,{'151.128'},{1},{'sfc'},{'Mean sea level pressure'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mcc'}     ,{'mcc'}     ,{1}     ,{'1'}         ,{'187.128'},{1},{'sfc'},{'Medium cloud cover'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sst'}     ,{'tos'}     ,{1}     ,{'K'}         ,{'34.128'} ,{1},{'sfc'},{'Sea surface temperature'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ci'}      ,{'ci'}      ,{1}     ,{'1'}         ,{'31.128'} ,{1},{'sfc'},{'Sea-Ice cover'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'src'}     ,{'src'}     ,{1}     ,{'m of water equivalent'},{'198.128'},{1},{'sfc'},{'Skin reservoir content'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'skt'}     ,{'skt'}     ,{1}     ,{'K'}         ,{'235.128'},{1},{'sfc'},{'Skin temperature'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'asn'}     ,{'albedosnow'},{1}   ,{'1'}         ,{'32.128'},{1},{'sfc'},{'Snow albedo'}])                                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'rsn'}     ,{'rsn'}     ,{1}    ,{'kg/m^3'}    ,{'33.128'},{1},{'sfc'},{'Snow density'}])                                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sd'}      ,{'sd'}      ,{1}    ,{'m of water equivalent'},{'141.128'},{1},{'sfc'},{'Snow depth (thickness of surface snow amount)'}]) ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl1'}    ,{'stl1'}    ,{1}     ,{'K'}         ,{'139.128'},{1},{'sfc'},{'Soil temperature level 1'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl2'}    ,{'stl2'}    ,{1}     ,{'K'}         ,{'170.128'},{1},{'sfc'},{'Soil temperature level 2'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl3'}    ,{'stl3'}    ,{1}     ,{'K'}         ,{'183.128'},{1},{'sfc'},{'Soil temperature level 3'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl4'}    ,{'stl4'}    ,{1}     ,{'K'}         ,{'236.128'},{1},{'sfc'},{'Soil temperature level 4'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sp'}      ,{'ps'}      ,{1}     ,{'Pa'}        ,{'134.128'},{1},{'sfc'},{'Surface pressure'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sr'}      ,{'sr'}      ,{1}     ,{'m'}         ,{'173.128'},{1},{'sfc'},{'Surface roughness length'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tsn'}     ,{'tsn'}     ,{1}     ,{'K'}         ,{'238.128'},{1},{'sfc'},{'Temperature of snow layer'}])                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tcc'}     ,{'tcc'}     ,{1}     ,{'1'}         ,{'164.128'},{1},{'sfc'},{'Total cloud cover'}])                              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tciw'}    ,{'tciw'}    ,{1}     ,{'kg/m^2'}    ,{'79.128'} ,{2},{'sfc'},{'Total column ice water'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tclw'}    ,{'tclw'}    ,{1}     ,{'kg/m^2'}    ,{'78.128'} ,{2},{'sfc'},{'Total column liquid water'}])                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tco3'}    ,{'tco3'}    ,{1}     ,{'kg/m^2'}    ,{'206.128'},{1},{'sfc'},{'Total column ozone'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tcw'}     ,{'tcw'}     ,{1}     ,{'kg/m^2'}    ,{'136.128'},{1},{'sfc'},{'Total column water'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tcwv'}    ,{'prw'}     ,{1}     ,{'kg/m^2'}    ,{'137.128'},{1},{'sfc'},{'Total column water vapor'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p57.162'} ,{'tclfw'}   ,{1}     ,{'kg/m^2'}    ,{'57.162'} ,{1},{'sfc'},{'Vertical integral of cloud frozen water'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p56.162'} ,{'tcllw'}   ,{1}     ,{'kg/m^2'}    ,{'56.162'} ,{1},{'sfc'},{'Vertical integral of cloud liquid water'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p80.162'} ,{'tcdivfw'} ,{1}     ,{'kg/m^2/s'}  ,{'80.162'} ,{1},{'sfc'},{'Vertical integral of divergence of cloud frozen water flux'}])   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p79.162'} ,{'tcdivl1'} ,{1}     ,{'kg/m^2/s'}  ,{'79.162'} ,{1},{'sfc'},{'Vertical integral of divergence of cloud liquid water flux'}])   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p85.162'} ,{'tcdivzg'} ,{1}     ,{'J/m^2'}     ,{'85.162'} ,{1},{'sfc'},{'Vertical integral of divergence of geopotential flux'}])         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p82.162'} ,{'tcdivke'} ,{1}     ,{'J/m^2'}     ,{'82.162'} ,{1},{'sfc'},{'Vertical integral of divergence of kinetic energy flux'}])       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p81.162'} ,{'tcdivmf'} ,{1}     ,{'kg/m^2/s'}  ,{'81.162'} ,{1},{'sfc'},{'Vertical integral of divergence of mass flux'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p84.162'} ,{'tcdivqf'} ,{1}     ,{'kg/m^2/s'}  ,{'84.162'} ,{1},{'sfc'},{'Vertical integral of divergence of moisture flux'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p87.162'} ,{'tcdivo3'} ,{1}     ,{'kg/m^2/s'}  ,{'87.162'} ,{1},{'sfc'},{'Vertical integral of divergence of ozone flux'}])                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p83.162'} ,{'tcdivhef'},{1}     ,{'J/m^2'}     ,{'83.162'} ,{1},{'sfc'},{'Vertical integral of divergence of thermal energy flux'}])       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p86.162'} ,{'tcdivtef'},{1}     ,{'J/m^2'}     ,{'86.162'} ,{1},{'sfc'},{'Vertical integral of divergence of total energy flux'}])         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p90.162'} ,{'tcecfwf'} ,{1}     ,{'kg/m/s'}    ,{'90.162'} ,{1},{'sfc'},{'Vertical integral of eastward cloud frozen water flux'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p88.162'} ,{'tceclwf'} ,{1}     ,{'kg/m/s'}    ,{'88.162'} ,{1},{'sfc'},{'Vertical integral of eastward cloud liquid water flux'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p73.162'} ,{'tcezgf'}  ,{1}     ,{'J/m^2'}     ,{'73.162'} ,{1},{'sfc'},{'Vertical integral of eastward geopotential flux'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p69.162'} ,{'tcehf'}   ,{1}     ,{'J/m^2'}     ,{'69.162'} ,{1},{'sfc'},{'Vertical integral of eastward heat flux'}])                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p67.162'} ,{'tcekef'}  ,{1}     ,{'J/m^2'}     ,{'67.162'} ,{1},{'sfc'},{'Vertical integral of eastard kinetic energy flux'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p65.162'} ,{'tcemf'}   ,{1}     ,{'kg/m/s'}    ,{'65.162'} ,{1},{'sfc'},{'Vertical integral of eastward mass flux'}])                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p77.162'} ,{'tceo3f'}  ,{1}     ,{'kg/m/s'}    ,{'77.162'} ,{1},{'sfc'},{'Vertical integral of eastward ozone flux'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p75.162'} ,{'tcetef'}  ,{1}     ,{'J/m^2'}     ,{'75.162'} ,{1},{'sfc'},{'Vertical integral of eastward total energy flux'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p71.162'} ,{'tcewvf'}  ,{1}     ,{'kg/m/s'}    ,{'71.162'} ,{1},{'sfc'},{'Vertical integral of eastward water vapor flux'}])               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p64.162'} ,{'tcec'}    ,{1}     ,{'J/m^2'}     ,{'64.162'} ,{1},{'sfc'},{'Vertical integral of energy conversion'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p59.162'} ,{'tcke'}    ,{1}     ,{'J/m^2'}     ,{'59.162'} ,{1},{'sfc'},{'Vertical integral of kinetic energy'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p53.162'} ,{'tcmass'}  ,{1}     ,{'kg/m^2'}    ,{'53.162'} ,{1},{'sfc'},{'Vertical integral of mass of atmosphere'}])                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p92.162'} ,{'tcmt'}    ,{1}     ,{'kg/m^2/s'}  ,{'92.162'} ,{1},{'sfc'},{'Vertical integral of mass tendency'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p91.162'} ,{'tcncfwf'} ,{1}     ,{'kg/m/s'}    ,{'91.162'} ,{1},{'sfc'},{'Vertical integral of northward cloud frozen water flux'}])       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p89.162'} ,{'tcnclwf'} ,{1}     ,{'kg/m/s'}    ,{'89.162'} ,{1},{'sfc'},{'Vertical integral of northward cloud liquid water flux'}])       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p74.162'} ,{'tcnzgf'}  ,{1}     ,{'J/m^2'}     ,{'74.162'} ,{1},{'sfc'},{'Vertical integral of northward geopotential flux'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p70.162'} ,{'tcnhf'}   ,{1}     ,{'J/m^2'}     ,{'70.162'} ,{1},{'sfc'},{'Vertical integral of northward heat flux'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p68.162'} ,{'tcnkef'}  ,{1}     ,{'J/m^2'}     ,{'68.162'} ,{1},{'sfc'},{'Vertical integral of northward kinetic energy flux'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p66.162'} ,{'tcnmf'}   ,{1}     ,{'kg/m/s'}    ,{'66.162'} ,{1},{'sfc'},{'Vertical integral of northward mass flux'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p78.162'} ,{'tcno3f'}  ,{1}     ,{'kg/m/s'}    ,{'78.162'} ,{1},{'sfc'},{'Vertical integral of northward ozone flux'}])                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p76.162'} ,{'tcntef'}  ,{1}     ,{'J/m^2'}     ,{'76.162'} ,{1},{'sfc'},{'Vertical integral of northward total energy flux'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p72.162'} ,{'tcnwvf'}  ,{1}     ,{'kg/m/s'}    ,{'72.162'} ,{1},{'sfc'},{'Vertical integral of northward water vapor flux'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p58.162'} ,{'tco3'}    ,{1}     ,{'kg/m^2'}    ,{'58.162'} ,{1},{'sfc'},{'Vertical integral of ozone'}])                                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p61.162'} ,{'tcdse'}   ,{1}     ,{'J/m^2'}     ,{'61.162'} ,{1},{'sfc'},{'Vertical integral of potential+internal energy'}])               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p62.162'} ,{'tcmse'}   ,{1}     ,{'J/m^2'}     ,{'62.162'} ,{1},{'sfc'},{'Vertical integral of potential+internal+latent energy'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p54.162'} ,{'tcta'}    ,{1}     ,{'K kg/m^2'}  ,{'54.162'} ,{1},{'sfc'},{'Vertical integral of temperature'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p60.162'} ,{'tche'}    ,{1}     ,{'J/m^2'}     ,{'60.162'} ,{1},{'sfc'},{'Vertical integral of thermal energy'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p63.162'} ,{'tcte'}    ,{1}     ,{'J/m^2'}     ,{'63.162'} ,{1},{'sfc'},{'Vertical integral of total energy'}])                            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p55.162'} ,{'tcwv'}    ,{1}     ,{'kg/m^2'}    ,{'55.162'} ,{1},{'sfc'},{'Vertical integral of water vapor'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl1'}   ,{'swvl1'}   ,{1}     ,{'m^2/m^3'}   ,{'39.128'} ,{1},{'sfc'},{'Volumetric soiol water layer 1'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl2'}   ,{'swvl2'}   ,{1}     ,{'m^2/m^3'}   ,{'40.128'} ,{1},{'sfc'},{'Volumetric soiol water layer 2'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl3'}   ,{'swvl3'}   ,{1}     ,{'m^2/m^3'}   ,{'41.128'} ,{1},{'sfc'},{'Volumetric soiol water layer 3'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl4'}   ,{'swvl4'}   ,{1}     ,{'m^2/m^3'}   ,{'42.128'} ,{1},{'sfc'},{'Volumetric soiol water layer 4'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'cc'}      ,{'cc'}      ,{1}     ,{'1'}         ,{'248.128'},{1},{'pl'} ,{'Cloud Cover'}])                                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'d'}       ,{'div'}     ,{1}     ,{'1/s'}       ,{'155.128'},{1},{'pl'} ,{'Divergence'}])                                                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'z'}       ,{'zg'}      ,{1/9.80616},{'m'}      ,{'129.128'},{1},{'pl'} ,{'Geopotential height'}])                                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'o3'}      ,{'o3'}      ,{1}     ,{'kg/kg'}     ,{'203.128'},{1},{'pl'} ,{'Ozone mass mixing ratio'}])                                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'pv'}      ,{'pv'}      ,{1}     ,{'K m^2/kg/s'},{'60.128'} ,{1},{'pl'} ,{'Potential vorticity'}])                                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'r'}       ,{'hur'}     ,{1}     ,{'%'}         ,{'157.128'},{1},{'pl'} ,{'Relative humidity'}])                                            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ciwc'}    ,{'ciwc'}    ,{1}     ,{'kg/kg'}     ,{'247.128'},{1},{'pl'} ,{'Specific cloud ice water content'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'clwc'}    ,{'clwc'}    ,{1}     ,{'kg/kg'}     ,{'246.128'},{1},{'pl'} ,{'Specific cloud liquid water content'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'q'}       ,{'hus'}     ,{1}     ,{'kg/kg'}     ,{'133.128'},{1},{'pl'} ,{'Specific humidity'}])                                            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'t'}       ,{'ta'}      ,{1}     ,{'K'}         ,{'130.128'},{1},{'pl'} ,{'Temperature'}])                                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'u'}       ,{'ua'}      ,{1}     ,{'m/s'}       ,{'131.128'},{1},{'pl'} ,{'Eastward component of wind'}])                                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'v'}       ,{'va'}      ,{1}     ,{'m/s'}       ,{'132.128'},{1},{'pl'} ,{'Northward component of wind'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'w'}       ,{'wap'}     ,{1}     ,{'Pa/s'}      ,{'135.128'},{1},{'pl'} ,{'Vertical (pressure) velocity'}])                                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'vo'}      ,{'vor'}     ,{1}     ,{'1/s'}       ,{'138.128'},{1},{'pl'} ,{'Relative vorticity'}])                                           ; qV = qV + 1 ;

totaltoc = 0 ;
Ext = 'eri' ;
longitude_dimname = 'longitude' ;
latitude_dimname  = 'latitude' ;
level_dimname     = 'level' ;
time_dimname      = 'time';
today = date ;
First_Year = 1900 ;
First_Month = 1 ;
First_Day = 1 ;
First_Hour = 0 ;
Last_Year = 2010 ;
Last_Month = 12 ;
Last_Day = 31 ;
Last_Hour = 21 ;
%
load(fullfile(fileparts(which('GOAT.m')),'Utils','DataManagementCode','ECMWF','DimsERAI.mat')) ;

Calendar = 'Monthly' ;
for res = 1:2
    tic
    for s = 2:size(CV,1)
        
        switch CV{s,6}
            case 2
                AF = 'fc' ;
                AFName = 'Forecast' ;
            otherwise
                AF = 'an' ;
                AFName = 'Analysis' ;
        end
        switch res
            case 1
                Data_LINK = fullfile(Data_ALP,'ERA20C_LINK','1_5X1_5',AFName,Calendar) ;
                lon = lon15 ;
                lat = lat15 ;
                gridstr = '1.5/1.5' ;
            case 2
                Data_LINK = fullfile(Data_ALP,'ERA20C_LINK','0_75X0_75',AFName,Calendar) ;
                lon = lon75 ;
                lat = lat75 ;
                gridstr = '0.75/0.75' ;
        end
        infostr = sprintf(['\nMonthly Means from Daily Means', ...
            '\nAbout ERA-20C (source: UCAR Climate Data Guide):', ...
            '\nERA-20C is ECMWF''s first atmospheric reanalysis of the 20th century, from 1900-2010. ', ...
            '\nIt assimilates observations of surface pressure and surface marine winds only. ', ... 
            '\nA coupled Atmosphere/Land-surface/Ocean-waves model is used to reanalyse the weather, by assimilating surface observations. ', ...
            '\nThe ERA-20C products describe the spatio-temporal evolution of the atmosphere (on 91 vertical levels, between the surface and 0.01 hPa), ', ...
            '\nthe land-surface (on 4 soil layers), and the ocean waves (on 25 frequencies and 12 directions).', ...
            '\nThe horizontal resolution is approximately 125 km (spectral truncation T159). Note, atmospheric data are not only available on the native 91 model levels, ', ...
            '\nbut also on 37 pressure levels (as in ERA-Interim), 16 potential temperature levels, and the 2 PVU potential vorticity level.' , ...
            '\nThe assimilation methodology is 24-hour 4D-Var analysis, with variational bias correction of surface pressure observations. ', ...
            '\nAnalysis increments are at T95 horizontal resolution (aprox. 210 km). The analyses provide the initial conditions for subsequent forecasts ', ...
            '\nthat serve as backgrounds to the next analyses. The spatio-temporal evolution of background errors was provided by a 10-member ensemble produced a priori  (Poli et al. (2013)).', ...
            '\nThe observations assimilated in ERA-20C include surface and mean sea level pressures from ISPDv3.2.6 and ICOADSv2.5.1, and surface marine winds from ICOADSv2.5.1. ']) ;
        
        
        if ~exist(Data_LINK,'dir')
            mkdir(Data_LINK) ;
        end
        save(fullfile(Data_LINK,'info.mat'),'infostr')
        VerticalOrdinate = 'Pressure (mb)' ;
        
        GOAT_Display_message(G,'','init')
        FieldName = CV{s,2} ;
        disp(['linking Monthly mean of ',FieldName,'  ',int2str(s-1),'/',int2str(size(CV,1)),'  . . . '])
        mkdir(fullfile(Data_LINK,FieldName)) ;
        %VerticalOrdinate =
        Units            = CV{s,4} ;
        FieldDescription = CV{s,8} ;
        % retrieve spatial vectors
        if strncmp(CV{s,7},'s',1)
            P = 1000 ;
        else
            P = P15 ;
        end
        
        save(fullfile(Data_LINK,FieldName,'Dims.mat'),'P','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
        Attributes = cell(2,5) ;
        qc = (Last_Year-First_Year+1)*12 ;
        Attributes(end,5) = {qc} ;
        Col = cell(1,2) ;
        % Column 1: OPeNDAP Address
        Col(1,1) = {['Col = cell(',int2str((Last_Year-First_Year+1)*12),',1) ; '  , ...
            'qf = 0 ; ' , ...
            'for y = ',int2str(First_Year),' : ',int2str(Last_Year),' ; ' , ...
            'for m = 1:12 ; '  , ...
            'qf = qf+1 ; Col(qf) = {int2str(y*10000 + m*100 + 1)} ; ' , ...
            'end ;  ' , ...
            'end ; ']} ;
        
        Col(1,2) = {'eval'} ;
        Attributes(1,1) = {Col} ;
        % Column 2: source varname
        Col(1,1) = CV(s,1) ;
        Col(1,2) = {qc} ;
        Attributes(1,2) = {Col} ;
        switch CV{s,7}
            case 'sfc' % lat,lon,time
                % Column 3: start
                Col(1,1) = {[1 1 1]} ;
                Col(1,2) = {qc} ;
                Attributes(1,3) = {Col} ;
                % Column 4: count
                count = [inf inf 1] ;
                Col(1,1) = {count} ;
                Col(1,2) = {qc} ;
                Attributes(1,4) = {Col} ;
            case 'pl' % lat lon level time
                % Column 3: start
                Col(1,1) = {[1 1 1 1]} ;
                Col(1,2) = {qc} ;
                Attributes(1,3) = {Col} ;
                % Column 4: count
                count = [inf inf inf 1] ;
                Col(1,1) = {count} ;
                Col(1,2) = {qc} ;
                Attributes(1,4) = {Col} ;
        end
        % Column 5: Factor
        Col(1,2) = {qc} ;
        Col(1,1) = CV(s,3)  ;
        Attributes(1,5) = {Col} ;
        
        Defs.MARSAttributes = {'dataset','era20c' ; ...
            'stream' ,'moda' ; ...
            'format' ,'netcdf'  ; ...
            'class'  ,'ei'      ; ...
            'levtype',CV{s,7} ; ...
            'type'   ,AF ; ...
            'param'  ,CV{s,5} ; ...
            'grid'   ,gridstr } ;
        if strcmpi(CV{s,7},'pl')
            Defs.MARSAttributes = [Defs.MARSAttributes ; {'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000'}] ;
        end
        Attributes(end,1) = {Ext} ; % 'eri'
        Attributes(end,2) = {[First_Year Last_Year]} ;
        Attributes(end,3) = {Defs} ; % Defs Struct
        Attributes(end,4) = {Calendar} ;
        
        %Attributes_check = GOAT_ALP_CompressAttributes(Attributes) ;
        
        save(fullfile(Data_LINK,FieldName,'link_field.mat'),'Attributes') ;
        J = 1 ; clear Text 
        Text(J,1) = {['GOAT variable name = ',FieldName]} ; J = J + 1 ; 
        Text(J,1) = {['NetCDF variable name = ',CV{s,1}]} ; J = J + 1 ; 
        Text(J,1) = {['First Year = ',int2str(First_Year)]} ; J = J + 1 ; 
        Text(J,1) = {['Last Year = ',int2str(Last_Year)]} ; J = J + 1 ; 
        Text(J,1) = {['Calendar = ',Calendar]} ; J = J + 1 ; 
        Text(J,1) = {['LINK Type = ',Ext]} ; J = J + 1 ; 
        GOAT_cell2txt(fullfile(Data_LINK,FieldName,'link_info.txt'),Text) ;
        if strcmp(FieldName,'ps')
            if ~exist(fullfile(Data_LINK,'BoerBeta'),'dir') ;
                mkdir(fullfile(Data_LINK,'BoerBeta')) ;
            end
            Attributes(end,1) = {'ers'} ;
            save(fullfile(Data_LINK,'BoerBeta','link_field.mat'),'Attributes') ;
            Text(1,1) = {['GOAT variable name = BoerBeta']} ;  
            Text(end,1) = {['LINK Type = ers']} ;  
            GOAT_cell2txt(fullfile(Data_LINK,'BoerBeta','link_info.txt'),Text) ;
            FieldDescription = 'Boer Beta Function' ;
            Units = '1' ;
            try
                P = P15 ;
                save(fullfile(Data_LINK,'BoerBeta','Dims.mat'),'P','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
            catch
                % 2D dataset Boer Beta is a place holder for other 3D datasets
            end
            
        end
    end % s
    
    TT = toc ;
    totaltoc = totaltoc + TT ;
    HH = floor(TT/3600) ;
    MM = floor((TT - HH*3600)/60) ;
    SS = TT - HH*3600 - MM*60 ;
    if HH > 0
        TimeString = [int2str(HH),' hours, ',int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
    elseif MM > 0
        TimeString = [int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
    elseif SS > 0
        TimeString = [int2str(SS),' seconds.'] ;
    end
    disp(['Linking Monthly ERA-20C resolution ',gridstr,' completed in ',TimeString]) ;
end % res


TT = totaltoc ;
HH = floor(TT/3600) ;
MM = floor((TT - HH*3600)/60) ;
SS = TT - HH*3600 - MM*60 ;
if HH > 0
    TimeString = [int2str(HH),' hours, ',int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
elseif MM > 0
    TimeString = [int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
elseif SS > 0
    TimeString = [int2str(SS),' seconds.'] ;
end
disp(['Linking Monthly ERA-20C via MARS API completed in ',TimeString]) ;

% Daily and DailyX4 LINKs
% Units and Name Conversion Array
CV = cell(1,8) ; qV = 1 ;
% A = flag for Forecast or Analysis: 0) both Forecast and Analysis 1) only analysis 2) only Forecast
% pl = flag for surface (sfc) or Pressure levels (pl)
% Fctr relates to 6hr fields
h6 = 1/21600 ; % convertion from  | J/m^2 to W/m^2 | N s/m^2 to N/m^2 |
hp6 = 1000/21600 ; % conversion from  | m of water equivalent to kg/m^2/s |
[CV(qV,:)] = deal([{'name'}    ,{'std_name'},{'Fctr'},{'Units'}     ,{'param'},{'A'},{'pl'} ,{'Description'}])                                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'u10'}     ,{'ua10m'}   ,{1}     ,{'m/s'}       ,{'165.128'},{0},{'sfc'},{'10 meter eastward wind component'}])                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'v10'}     ,{'va10m'}   ,{1}     ,{'m/s'}       ,{'166.128'},{0},{'sfc'},{'10 meter northward wind component'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'fg10'}    ,{'fg10'}    ,{1}     ,{'m/s'}       ,{'49.128'} ,{2} ,{'sfc'},{'10 meter wind gust since previous post-processing'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'d2m'}     ,{'d2m'}     ,{1}     ,{'K'}         ,{'168.128'},{0},{'sfc'},{'2 meter dew point temperature'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'t2m'}     ,{'at2m'}    ,{1}     ,{'K'}         ,{'167.128'},{0},{'sfc'},{'2 meter temeprature'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'al'}      ,{'albedo'}  ,{1}     ,{'1'}         ,{'174.128'},{1},{'sfc'},{'Surface albedo'}])                                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'bld'}     ,{'bld'}     ,{h6}    ,{'W/m^2'}     ,{'145.128'},{2},{'sfc'},{'Bounday Layer dissipation rate (energy dissipation in atmospheric boundary layer)'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'blh'}     ,{'blh'}     ,{1}     ,{'m'}         ,{'159.128'},{2},{'sfc'},{'Bounday Layer Height'}])                              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'chnk'}    ,{'charnock'},{1}     ,{'None'}      ,{'148.128'},{0},{'sfc'},{'Charnock'}])                                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'parcs'}   ,{'parcs'}   ,{h6}    ,{'W/m^2'}     ,{'20.128'} ,{2},{'sfc'},{'Clear sky surface photosynthetically active radiation'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'cape'}    ,{'cape'}    ,{1}     ,{'J/kg'}      ,{'59.128'} ,{2},{'sfc'},{'Convective available potential energy'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'cp'}      ,{'prconv'}  ,{hp6}   ,{'kg/m^2/s'}  ,{'143.128'},{2},{'sfc'},{'Convective precipitation rate'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'csf'}     ,{'prsnow'}  ,{hp6}   ,{'kg/m^2/s'}  ,{'239.128'},{2},{'sfc'},{'Convective snowfall rate'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'uvb'}     ,{'ruvds'}   ,{h6}    ,{'W/m^2'}     ,{'57.128'} ,{2},{'sfc'},{'Downward UV radiation at surface'}])                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lgws'}    ,{'lgws'}    ,{h6}    ,{'N/m^2'}     ,{'195.128'},{2},{'sfc'},{'Eastward gravity wave surface stress'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ewss'}    ,{'ewss'}    ,{h6}    ,{'N/m^2'}     ,{'180.128'},{2},{'sfc'},{'Eastward turbulent surface stress'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'e'}       ,{'er'}      ,{hp6}   ,{'kg/m^2/s'}  ,{'182.128'},{2},{'sfc'},{'Evaporation rate'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'fal'}     ,{'albdeo'}  ,{1}     ,{'1'}         ,{'243.128'},{2},{'sfc'},{'Forecast Albedo'}])                                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'flsr'}    ,{'lsrh'}    ,{1}     ,{'None'}      ,{'245.128'},{2},{'sfc'},{'Forecast logarithm of surface roughness for heat'}])  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'fsr'}     ,{'sr'}      ,{1}     ,{'m'}         ,{'244.128'},{2},{'sfc'},{'Forecast surface roughness length'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'gwd'}     ,{'gwd'}     ,{h6}    ,{'W/m^2'}     ,{'197.128'},{2},{'sfc'},{'Gravity wave dissipation rate'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'hcc'}     ,{'hcc'}     ,{1}     ,{'1'}         ,{'188.128'},{0},{'sfc'},{'High cloud cover'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl1'}   ,{'istl1'}   ,{1}     ,{'K'}         ,{'35.128'} ,{0},{'sfc'},{'Ice temperature layer 1'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl2'}   ,{'istl2'}   ,{1}     ,{'K'}         ,{'36.128'} ,{0},{'sfc'},{'Ice temperature layer 2'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl3'}   ,{'istl3'}   ,{1}     ,{'K'}         ,{'37.128'} ,{0},{'sfc'},{'Ice temperature layer 3'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'istl4'}   ,{'istl4'}   ,{1}     ,{'K'}         ,{'38.128'} ,{0},{'sfc'},{'Ice temperature layer 4'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'iews'}    ,{'iews'}    ,{1}     ,{'N/m^2'}     ,{'229.128'},{2},{'sfc'},{'Instantaneous eastward turbulent surface stress'}])   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ie'}      ,{'ie'}      ,{1}     ,{'Kg/m^2/s'}  ,{'232.128'},{2},{'sfc'},{'Instantaneous moisture flux'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'inss'}    ,{'inss'}    ,{1}     ,{'N/m^2'}     ,{'230.128'},{2},{'sfc'},{'Instantaneous northward turbulent surface stress'}])  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ishf'}    ,{'ishf'}    ,{1}     ,{'W/m^2'}     ,{'231.128'},{2},{'sfc'},{'Instantaneous surface sensible heat flux'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lsp'}     ,{'prls'}    ,{hp6}   ,{'kg/m^2/s'}  ,{'142.128'},{2},{'sfc'},{'Large scale precipitation rate'}])                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lspf'}    ,{'prlsf'}   ,{h6}    ,{'1'}         ,{'50.128'} ,{2},{'sfc'},{'Large scale precipitation rate fraction'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lsf'}     ,{'prlssn'}  ,{hp6}   ,{'kg/m^2/s'}  ,{'240.128'},{2},{'sfc'},{'Large scale snowfall rate'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lsrh'}    ,{'lsrh'}    ,{1}     ,{'None'}      ,{'234.128'},{1},{'sfc'},{'Logarithm of surface roughness for heat'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lcc'}     ,{'lcc'}     ,{1}     ,{'1'}         ,{'186.128'},{0},{'sfc'},{'Low cloud cover'}])                                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mx2t'}    ,{'tasmax2'} ,{1}     ,{'K'}         ,{'201.128'},{2},{'sfc'},{'Maximum temperature at 2 meter since previous post-processing'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'msl'}     ,{'psl'}     ,{1}     ,{'Pa'}        ,{'151.128'},{0},{'sfc'},{'Mean sea level pressure'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mwd'}     ,{'mwd'}     ,{1}     ,{'degrees'}   ,{'230.140'},{1},{'sfc'},{'Mean wave direction'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mwp'}     ,{'mwp'}     ,{1}     ,{'s'}         ,{'232.140'},{1},{'sfc'},{'Mean wave period'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mcc'}     ,{'mcc'}     ,{1}     ,{'1'}         ,{'187.128'},{0},{'sfc'},{'Medium cloud cover'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mn2t'}    ,{'tasmin2'} ,{1}     ,{'K'}         ,{'202.128'},{2},{'sfc'},{'Minimum temperature at 2 meter since previous post-processing'}]) ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'mgws'}    ,{'mgws'}    ,{h6}    ,{'N/m^2'}     ,{'196.128'},{2},{'sfc'},{'Northward gravity wave surface stress'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'nsss'}    ,{'nsss'}    ,{h6}    ,{'N/m^2'}     ,{'181.128'},{2},{'sfc'},{'Northward turbulent surface stress'}])                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'par'}     ,{'par'}     ,{h6}    ,{'W/m^2'}     ,{'58.128'} ,{2},{'sfc'},{'Photosynthetically active radiation at the surface'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'ro'}      ,{'runoff'}  ,{hp6}   ,{'kg/m^2/s'}  ,{'205.128'},{2},{'sfc'},{'Runoff rate'}])                                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sst'}     ,{'tos'}     ,{1}     ,{'K'}         ,{'34.128'} ,{0},{'sfc'},{'Sea surface temperature'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ci'}      ,{'ci'}      ,{1}     ,{'1'}         ,{'31.128'} ,{0},{'sfc'},{'Sea-Ice cover'}])                                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swh'}     ,{'swh'}     ,{1}     ,{'m'}         ,{'229.140'},{1},{'sfc'},{'Significant height of combined wind waves and swell'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'src'}     ,{'src'}     ,{1}     ,{'m of water equivalent'},{'198.128'},{0},{'sfc'},{'Skin reservoir content'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'skt'}     ,{'skt'}     ,{1}     ,{'K'}         ,{'235.128'},{0},{'sfc'},{'Skin temperature'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'asn'}     ,{'albedosnow'},{1}   ,{'1'}         ,{'32.128'} ,{0},{'sfc'},{'Snow albedo'}])                                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'rsn'}     ,{'rsn'}     ,{1}     ,{'kg/m^3'}    ,{'33.128'} ,{0},{'sfc'},{'Snow density'}])                                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sd'}      ,{'sd'}      ,{1}     ,{'m of water equivalent'},{'141.128'},{0},{'sfc'},{'Snow depth (thickness of surface snow amount)'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'es'}      ,{'ers'}     ,{hp6}   ,{'kg/m^2/s'}  ,{'44.128'} ,{2},{'sfc'},{'Snow evaporation rate'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sf'}      ,{'prsf'}    ,{hp6}   ,{'kg/m^2/s'}  ,{'144.128'},{2},{'sfc'},{'Snowfall rate'}])                                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'smlt'}    ,{'smlt'}    ,{hp6}   ,{'kg/m^2/s'}  ,{'45.128'} ,{2},{'sfc'} ,{'Snowmelt rate'}])                                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl1'}    ,{'stl1'}    ,{1}     ,{'K'}         ,{'139.128'},{0},{'sfc'},{'Soil temperature level 1'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl2'}    ,{'stl2'}    ,{1}     ,{'K'}         ,{'170.128'},{0},{'sfc'},{'Soil temperature level 2'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl3'}    ,{'stl3'}    ,{1}     ,{'K'}         ,{'183.128'},{0},{'sfc'},{'Soil temperature level 3'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'stl4'}    ,{'stl4'}    ,{1}     ,{'K'}         ,{'236.128'},{0},{'sfc'},{'Soil temperature level 4'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sund'}    ,{'sund'}    ,{1}     ,{'s'}         ,{'189.128'},{2},{'sfc'},{'Sunshine duration'}])                                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'slhf'}    ,{'hfls'}    ,{h6}    ,{'W/m^2'}     ,{'147.128'},{2},{'sfc'},{'Surface latent heat flux'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ssr'}     ,{'rsns'}    ,{h6}    ,{'W/m^2'}     ,{'176.128'},{2},{'sfc'},{'Surface net solar radiation'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ssrc'}    ,{'rsnscs'}  ,{h6}    ,{'W/m^2'}     ,{'210.128'},{2},{'sfc'},{'Surface net solar radiation, clear sky'}])            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'str'}     ,{'rlns'}    ,{h6}    ,{'W/m^2'}     ,{'177.128'},{2},{'sfc'},{'Surface net thermal radiation'}])                     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'strc'}    ,{'rlnscs'}  ,{h6}    ,{'W/m^2'}     ,{'211.128'},{2},{'sfc'},{'Surface net thermal radiation, clear sky'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sp'}      ,{'ps'}      ,{1}     ,{'Pa'}        ,{'134.128'},{0},{'sfc'},{'Surface pressure'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sr'}      ,{'sr'}      ,{1}     ,{'m'}         ,{'173.128'},{1},{'sfc'},{'Surface roughness length'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sshf'}    ,{'hfss'}    ,{h6}    ,{'W/m^2'}     ,{'146.128'},{2},{'sfc'},{'Surface sensible heat flux'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ssrd'}    ,{'rsds'}    ,{h6}    ,{'W/m^2'}     ,{'169.128'},{2},{'sfc'},{'Surface solar radiation downwards'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'strd'}    ,{'rlds'}    ,{h6}    ,{'W/m^2'}     ,{'175.128'},{2},{'sfc'},{'Surface thermal radiation downwards'}])               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tisr'}    ,{'rsdt'}    ,{h6}    ,{'W/m^2'}     ,{'212.128'},{2},{'sfc'},{'TOA incident solar radiation'}])                      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tsn'}     ,{'tsn'}     ,{1}     ,{'K'}         ,{'238.128'},{0},{'sfc'},{'Temperature of snow layer'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tsr'}     ,{'rsnt'}    ,{h6}    ,{'W/m^2'}     ,{'178.128'},{2},{'sfc'},{'Top net solar radiation'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tsrc'}    ,{'rsntcs'}  ,{h6}    ,{'W/m^2'}     ,{'208.128'},{2},{'sfc'},{'Top net solar radiation, clear sky'}])                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ttr'}     ,{'rlnt'}    ,{h6}    ,{'W/m^2'}     ,{'179.128'},{2},{'sfc'},{'Top net thermal radiation'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ttrc'}    ,{'rlntcs'}  ,{h6}    ,{'W/m^2'}     ,{'209.128'},{2},{'sfc'},{'Top net thermal radiation, clear sky'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tcc'}     ,{'tcc'}     ,{1}     ,{'1'}         ,{'164.128'},{0},{'sfc'},{'Total cloud cover'}])                                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tciw'}    ,{'tciw'}    ,{1}     ,{'kg/m^2'}    ,{'79.128'} ,{2},{'sfc'},{'Total column ice water'}])                            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tclw'}    ,{'tclw'}    ,{1}     ,{'kg/m^2'}    ,{'78.128'} ,{2},{'sfc'},{'Total column liquid water'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tco3'}    ,{'tco3'}    ,{1}     ,{'kg/m^2'}    ,{'206.128'},{0},{'sfc'},{'Total column ozone'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tcw'}     ,{'tcw'}     ,{1}     ,{'kg/m^2'}    ,{'136.128'},{0},{'sfc'},{'Total column water'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tcwv'}    ,{'prw'}     ,{1}     ,{'kg/m^2'}    ,{'137.128'},{0},{'sfc'},{'Total column water vapor'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tp'}      ,{'pr'}      ,{hp6}   ,{'kg/m^2/s'}  ,{'228.128'},{2},{'sfc'},{'Total precipitation'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p57.162'} ,{'tclfw'}   ,{1}     ,{'kg/m^2'}    ,{'57.162'} ,{1},{'sfc'},{'Vertical integral of cloud frozen water'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p56.162'} ,{'tcllw'}   ,{1}     ,{'kg/m^2'}    ,{'56.162'} ,{1},{'sfc'},{'Vertical integral of cloud liquid water'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p80.162'} ,{'tcdivfw'} ,{1}     ,{'kg/m^2/s'}  ,{'80.162'} ,{1},{'sfc'},{'Vertical integral of divergence of cloud frozen water flux'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'p79.162'} ,{'tcdivl1'} ,{1}     ,{'kg/m^2/s'}  ,{'79.162'} ,{1},{'sfc'},{'Vertical integral of divergence of cloud liquid water flux'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'p85.162'} ,{'tcdivzg'} ,{1}     ,{'J/m^2'}     ,{'85.162'} ,{1},{'sfc'},{'Vertical integral of divergence of geopotential flux'}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p82.162'} ,{'tcdivke'} ,{1}     ,{'J/m^2'}     ,{'82.162'} ,{1},{'sfc'},{'Vertical integral of divergence of kinetic energy flux'}])    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p81.162'} ,{'tcdivmf'} ,{1}     ,{'kg/m^2/s'}  ,{'81.162'} ,{1},{'sfc'},{'Vertical integral of divergence of mass flux'}])              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p84.162'} ,{'tcdivqf'} ,{1}     ,{'kg/m^2/s'}  ,{'84.162'} ,{1},{'sfc'},{'Vertical integral of divergence of moisture flux'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p87.162'} ,{'tcdivo3'} ,{1}     ,{'kg/m^2/s'}  ,{'87.162'} ,{1},{'sfc'},{'Vertical integral of divergence of ozone flux'}])             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p83.162'} ,{'tcdivhef'},{1}     ,{'J/m^2'}     ,{'83.162'} ,{1},{'sfc'},{'Vertical integral of divergence of thermal energy flux'}])    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p86.162'} ,{'tcdivtef'},{1}     ,{'J/m^2'}     ,{'86.162'} ,{1},{'sfc'},{'Vertical integral of divergence of total energy flux'}])      ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p90.162'} ,{'tcecfwf'} ,{1}     ,{'kg/m/s'}    ,{'90.162'} ,{1},{'sfc'},{'Vertical integral of eastward cloud frozen water flux'}])     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p88.162'} ,{'tceclwf'} ,{1}     ,{'kg/m/s'}    ,{'88.162'} ,{1},{'sfc'},{'Vertical integral of eastward cloud liquid water flux'}])     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p73.162'} ,{'tcezgf'}  ,{1}     ,{'J/m^2'}     ,{'73.162'} ,{1},{'sfc'},{'Vertical integral of eastward geopotential flux'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p69.162'} ,{'tcehf'}   ,{1}     ,{'J/m^2'}     ,{'69.162'} ,{1},{'sfc'},{'Vertical integral of eastward heat flux'}])                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p67.162'} ,{'tcekef'}  ,{1}     ,{'J/m^2'}     ,{'67.162'} ,{1},{'sfc'},{'Vertical integral of eastard kinetic energy flux'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p65.162'} ,{'tcemf'}   ,{1}     ,{'kg/m/s'}    ,{'65.162'} ,{1},{'sfc'},{'Vertical integral of eastward mass flux'}])                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p77.162'} ,{'tceo3f'}  ,{1}     ,{'kg/m/s'}    ,{'77.162'} ,{1},{'sfc'},{'Vertical integral of eastward ozone flux'}])                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p75.162'} ,{'tcetef'}  ,{1}     ,{'J/m^2'}     ,{'75.162'} ,{1},{'sfc'},{'Vertical integral of eastward total energy flux'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p71.162'} ,{'tcewvf'}  ,{1}     ,{'kg/m/s'}    ,{'71.162'} ,{1},{'sfc'},{'Vertical integral of eastward water vapor flux'}])            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p64.162'} ,{'tcec'}    ,{1}     ,{'J/m^2'}     ,{'64.162'} ,{1},{'sfc'},{'Vertical integral of energy conversion'}])                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p59.162'} ,{'tcke'}    ,{1}     ,{'J/m^2'}     ,{'59.162'} ,{1},{'sfc'},{'Vertical integral of kinetic energy'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p53.162'} ,{'tcmass'}  ,{1}     ,{'kg/m^2'}    ,{'53.162'} ,{1},{'sfc'},{'Vertical integral of mass of atmosphere'}])                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p92.162'} ,{'tcmt'}    ,{1}     ,{'kg/m^2/s'}  ,{'92.162'} ,{1},{'sfc'},{'Vertical integral of mass tendency'}])                        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p91.162'} ,{'tcncfwf'} ,{1}     ,{'kg/m/s'}    ,{'91.162'} ,{1},{'sfc'},{'Vertical integral of northward cloud frozen water flux'}])    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p89.162'} ,{'tcnclwf'} ,{1}     ,{'kg/m/s'}    ,{'89.162'} ,{1},{'sfc'},{'Vertical integral of northward cloud liquid water flux'}])    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p74.162'} ,{'tcnzgf'}  ,{1}     ,{'J/m^2'}     ,{'74.162'} ,{1},{'sfc'},{'Vertical integral of northward geopotential flux'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p70.162'} ,{'tcnhf'}   ,{1}     ,{'J/m^2'}     ,{'70.162'} ,{1},{'sfc'},{'Vertical integral of northward heat flux'}])                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p68.162'} ,{'tcnkef'}  ,{1}     ,{'J/m^2'}     ,{'68.162'} ,{1},{'sfc'},{'Vertical integral of northward kinetic energy flux'}])        ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p66.162'} ,{'tcnmf'}   ,{1}     ,{'kg/m/s'}    ,{'66.162'} ,{1},{'sfc'},{'Vertical integral of northward mass flux'}])                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p78.162'} ,{'tcno3f'}  ,{1}     ,{'kg/m/s'}    ,{'78.162'} ,{1},{'sfc'},{'Vertical integral of northward ozone flux'}])                 ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p76.162'} ,{'tcntef'}  ,{1}     ,{'J/m^2'}     ,{'76.162'} ,{1},{'sfc'},{'Vertical integral of northward total energy flux'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p72.162'} ,{'tcnwvf'}  ,{1}     ,{'kg/m/s'}    ,{'72.162'} ,{1},{'sfc'},{'Vertical integral of northward water vapor flux'}])           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p58.162'} ,{'tco3'}    ,{1}     ,{'kg/m^2'}    ,{'58.162'} ,{1},{'sfc'},{'Vertical integral of ozone'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p61.162'} ,{'tcdse'}   ,{1}     ,{'J/m^2'}     ,{'61.162'} ,{1},{'sfc'},{'Vertical integral of potential+internal energy'}])            ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p62.162'} ,{'tcmse'}   ,{1}     ,{'J/m^2'}     ,{'62.162'} ,{1},{'sfc'},{'Vertical integral of potential+internal+latent energy'}])     ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p54.162'} ,{'tcta'}    ,{1}     ,{'K kg/m^2'}  ,{'54.162'} ,{1},{'sfc'},{'Vertical integral of temperature'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p60.162'} ,{'tche'}    ,{1}     ,{'J/m^2'}     ,{'60.162'} ,{1},{'sfc'},{'Vertical integral of thermal energy'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p63.162'} ,{'tcte'}    ,{1}     ,{'J/m^2'}     ,{'63.162'} ,{1},{'sfc'},{'Vertical integral of total energy'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'p55.162'} ,{'tcwv'}    ,{1}     ,{'kg/m^2'}    ,{'55.162'} ,{1},{'sfc'},{'Vertical integral of water vapor'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl1'}   ,{'swvl1'}   ,{1}     ,{'m^2/m^3'}   ,{'39.128'} ,{0},{'sfc'},{'Volumetric soil water layer 1'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl2'}   ,{'swvl2'}   ,{1}     ,{'m^2/m^3'}   ,{'40.128'} ,{0},{'sfc'},{'Volumetric soil water layer 2'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl3'}   ,{'swvl3'}   ,{1}     ,{'m^2/m^3'}   ,{'41.128'} ,{0},{'sfc'},{'Volumetric soil water layer 3'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'swvl4'}   ,{'swvl4'}   ,{1}     ,{'m^2/m^3'}   ,{'42.128'} ,{0},{'sfc'},{'Volumetric soil water layer 4'}])                             ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'cc'}      ,{'cc'}      ,{1}     ,{'1'}         ,{'248.128'},{1},{'pl'} ,{'Cloud Cover'}])                                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'d'}       ,{'div'}     ,{1}     ,{'1/s'}       ,{'155.128'},{1},{'pl'} ,{'Divergence'}])                                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'z'}       ,{'zg'}      ,{1/9.80616},{'m'}      ,{'129.128'},{1},{'pl'} ,{'Geopotential height'}])                                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'o3'}      ,{'o3'}      ,{1}     ,{'kg/kg'}     ,{'203.128'},{1},{'pl'} ,{'Ozone mass mixing ratio'}])                                   ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'pv'}      ,{'pv'}      ,{1}     ,{'K m^2/kg/s'},{'60.128'} ,{1},{'pl'} ,{'Potential vorticity'}])                                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'r'}       ,{'hur'}     ,{1}     ,{'%'}         ,{'157.128'},{1},{'pl'} ,{'Relative humidity'}])                                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'ciwc'}    ,{'ciwc'}    ,{1}     ,{'kg/kg'}     ,{'247.128'},{1},{'pl'} ,{'Specific cloud ice water content'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'clwc'}    ,{'clwc'}    ,{1}     ,{'kg/kg'}     ,{'246.128'},{1},{'pl'} ,{'Specific cloud liquid water content'}])                       ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'q'}       ,{'hus'}     ,{1}     ,{'kg/kg'}     ,{'133.128'},{1},{'pl'} ,{'Specific humidity'}])                                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'t'}       ,{'ta'}      ,{1}     ,{'K'}         ,{'130.128'},{1},{'pl'} ,{'Temperature'}])                                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'u'}       ,{'ua'}      ,{1}     ,{'m/s'}       ,{'131.128'},{1},{'pl'} ,{'Eastward component of wind'}])                                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'v'}       ,{'va'}      ,{1}     ,{'m/s'}       ,{'132.128'},{1},{'pl'} ,{'Northward component of wind'}])                               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'w'}       ,{'wap'}     ,{1}     ,{'Pa/s'}      ,{'135.128'},{1},{'pl'} ,{'Vertical (pressure) velocity'}])                              ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'vo'}      ,{'vor'}     ,{1}     ,{'1/s'}       ,{'138.128'},{1},{'pl'} ,{'Relative vorticity'}])                                        ; qV = qV + 1 ;

totaltoc = 0 ;
Ext = 'eri' ;
longitude_dimname = 'longitude' ;
latitude_dimname  = 'latitude' ;
level_dimname     = 'level' ;
time_dimname      = 'time';
today = date ;
First_Year = 1900 ;
First_Month = 1 ;
First_Day = 1 ;
First_Hour = 0 ;
Last_Year = 2010 ;
Last_Month = 12 ;
Last_Day = 31 ;
Last_Hour = 21 ;
%
load(fullfile(fileparts(which('GOAT.m')),'Utils','DataManagementCode','ECMWF','DimsERAI.mat')) ;


for res = 1:2
    for cal = 1:1 % DailyX4 and DailyX8 to be completed
        for ana = 1:2
            tic
            switch cal
                case 1
                    Calendar = 'Daily' ;
                case 2
                    Calendar = 'DailyX4' ;
                case 3
                    Calendar = 'DailyX8' ;
            end
            switch ana
                case 1
                    Analysis = 1 ; % Analysis
                case 2
                    Analysis = 2 ; % Forecast
            end
            for s = 2:size(CV,1)
                param = CV{s,5} ;
                if strcmp(param(end-2:end),'140')
                    stream = 'wave' ;
                else
                    stream = 'moda' ;
                end
                switch Analysis
                    case 1 % Analysis
                        switch CV{s,6}
                            case 2
                                continue ;
                            otherwise
                                AF = 'an' ;
                                AFName = 'Analysis' ;
                        end
                    case 2
                        switch CV{s,6}
                            case 1
                                continue ;
                            otherwise
                                AF = 'fc' ;
                                AFName = 'Forecast' ;
                        end
                end
                switch res
                    case 1
                        Data_LINK = fullfile(Data_ALP,'ERA20C_LINK','1_5X1_5',AFName,Calendar) ;
                        lon = lon15 ;
                        lat = lat15 ;
                        gridstr = '1.5/1.5' ;
                    case 2
                        Data_LINK = fullfile(Data_ALP,'ERA20C_LINK','0_75X0_75',AFName,Calendar) ;
                        lon = lon75 ;
                        lat = lat75 ;
                        gridstr = '0.75/0.75' ;
                end
                switch Calendar
                    case 'Daily'
                        CalendarStr = 'Daily averages (of 8 times daily)' ;
                    case 'DailyX4'
                        CalendarStr = '4 times Daily)' ;
                    case 'DailyX8'
                        CalendarStr = '8 times Daily)' ;
                end
                
                infostr = sprintf([CalendarStr, ' ',AFName,' fields at ',gridstr,' degree spatial resolution.', ...
                    '\nAbout ERA-20C (source: UCAR Climate Data Guide):', ...
            '\nERA-20C is ECMWF''s first atmospheric reanalysis of the 20th century, from 1900-2010. ', ...
            '\nIt assimilates observations of surface pressure and surface marine winds only. ', ... 
            '\nA coupled Atmosphere/Land-surface/Ocean-waves model is used to reanalyse the weather, by assimilating surface observations. ', ...
            '\nThe ERA-20C products describe the spatio-temporal evolution of the atmosphere (on 91 vertical levels, between the surface and 0.01 hPa), ', ...
            '\nthe land-surface (on 4 soil layers), and the ocean waves (on 25 frequencies and 12 directions).', ...
            '\nThe horizontal resolution is approximately 125 km (spectral truncation T159). Note, atmospheric data are not only available on the native 91 model levels, ', ...
            '\nbut also on 37 pressure levels (as in ERA-Interim), 16 potential temperature levels, and the 2 PVU potential vorticity level.' , ...
            '\nThe assimilation methodology is 24-hour 4D-Var analysis, with variational bias correction of surface pressure observations. ', ...
            '\nAnalysis increments are at T95 horizontal resolution (aprox. 210 km). The analyses provide the initial conditions for subsequent forecasts ', ...
            '\nthat serve as backgrounds to the next analyses. The spatio-temporal evolution of background errors was provided by a 10-member ensemble produced a priori  (Poli et al. (2013)).', ...
            '\nThe observations assimilated in ERA-20C include surface and mean sea level pressures from ISPDv3.2.6 and ICOADSv2.5.1, and surface marine winds from ICOADSv2.5.1. ']) ;
                
                
                if ~exist(Data_LINK,'dir')
                    mkdir(Data_LINK) ;
                end
                save(fullfile(Data_LINK,'info.mat'),'infostr')
                VerticalOrdinate = 'Pressure (mb)' ;
                
                GOAT_Display_message(G,'','init')
                FieldName = CV{s,2} ;
                disp(['linking ',gridstr,'  ',Calendar,' ',AFName,'  ',FieldName,'  ',int2str(s-1),'/',int2str(size(CV,1)),'  . . . '])
                mkdir(fullfile(Data_LINK,FieldName)) ;
                %VerticalOrdinate =
                Units            = CV{s,4} ;
                FieldDescription = CV{s,8} ;
                % retrieve spatial vectors
                if strncmp(CV{s,7},'s',1)
                    P = 1000 ;
                else
                    P = P15 ;
                end
                
                save(fullfile(Data_LINK,FieldName,'Dims.mat'),'P','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
                Attributes = cell(2,5) ;
                qc = GOAT_getSerial(Last_Year,Last_Month,Last_Day,Last_Hour,Calendar,First_Year) ;
                Attributes(end,5) = {qc} ;
                switch Calendar
                    case 'Daily'
                        switch AFName
                            case 'Analysis'
                                Attributes_1 = cell(8,1) ;
                                Attributes_2 = cell(8,1) ;
                                Attributes_3 = cell(8,1) ;
                                Attributes_4 = cell(8,1) ;
                                Attributes_5 = cell(8,1) ;
                                Attributes_9 = cell(8,1) ;
                                Col = cell(1,2) ;
                                % Column 1: Date
                                Col(1,1) = {['Col = cell(',int2str(qc),',1) ; '  , ...
                                    'qf = 0 ; ' , ...
                                    'for y = ',int2str(First_Year),' : ',int2str(Last_Year),' ; ' , ...
                                    ' for m = 1:12 ; '  , ...
                                    '  for d = 1:GOAT_DaysInMonth(m,y)  ; ' , ...
                                    '   qf = qf+1 ; ' , ...
                                    '   daynum = int2str(y*10000 + m*100 + d) ; ' , ...
                                    '    Col(qf) = {{daynum ; daynum ; daynum ; daynum ; daynum ; daynum ; daynum ; daynum}} ; ' , ...
                                    '  end ;  ' , ...
                                    ' end ;  ' , ...
                                    'end ; ']} ;
                                Col(1,2) = {'eval'} ;
                                Attributes(1,1) = {Col} ;
                                Attributes_2(1,1) = CV(s,1) ;
                                Attributes_2(2,1) = CV(s,1) ;
                                Attributes_2(3,1) = CV(s,1) ;
                                Attributes_2(4,1) = CV(s,1) ;
                                Attributes_2(5,1) = CV(s,1) ;
                                Attributes_2(6,1) = CV(s,1) ;
                                Attributes_2(7,1) = CV(s,1) ;
                                Attributes_2(8,1) = CV(s,1) ;
                                Col(1,1) = {Attributes_2} ;
                                Col(1,2) = {qc} ;
                                Attributes(1,2) = {Col} ;
                                switch CV{s,7}
                                    case 'sfc' % lat,lon,time
                                        % Column 3: start
                                        Attributes_3(1,1) = {[1 1 1]} ;
                                        Attributes_3(2,1) = {[1 1 1]} ;
                                        Attributes_3(3,1) = {[1 1 1]} ;
                                        Attributes_3(4,1) = {[1 1 1]} ;
                                        Attributes_3(5,1) = {[1 1 1]} ;
                                        Attributes_3(6,1) = {[1 1 1]} ;
                                        Attributes_3(7,1) = {[1 1 1]} ;
                                        Attributes_3(8,1) = {[1 1 1]} ;
                                        Col(1,1) = {Attributes_3} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,3) = {Col} ;
                                        % Column 4: count
                                        count = [inf inf 1] ;
                                        Attributes_4(1,1) = {count} ;
                                        Attributes_4(2,1) = {count} ;
                                        Attributes_4(3,1) = {count} ;
                                        Attributes_4(4,1) = {count} ;
                                        Attributes_4(5,1) = {count} ;
                                        Attributes_4(6,1) = {count} ;
                                        Attributes_4(7,1) = {count} ;
                                        Attributes_4(8,1) = {count} ;
                                        Col(1,1) = {Attributes_4} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,4) = {Col} ;
                                    case 'pl' % lat lon level time
                                        Attributes_3(1,1) = {[1 1 1 1]} ;
                                        Attributes_3(2,1) = {[1 1 1 1]} ;
                                        Attributes_3(3,1) = {[1 1 1 1]} ;
                                        Attributes_3(4,1) = {[1 1 1 1]} ;
                                        Attributes_3(5,1) = {[1 1 1 1]} ;
                                        Attributes_3(6,1) = {[1 1 1 1]} ;
                                        Attributes_3(7,1) = {[1 1 1 1]} ;
                                        Attributes_3(8,1) = {[1 1 1 1]} ;
                                        Col(1,1) = {Attributes_3} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,3) = {Col} ;
                                        % Column 4: count
                                        count = [inf inf inf 1] ;
                                        Attributes_4(1,1) = {count} ;
                                        Attributes_4(2,1) = {count} ;
                                        Attributes_4(3,1) = {count} ;
                                        Attributes_4(4,1) = {count} ;
                                        Attributes_4(5,1) = {count} ;
                                        Attributes_4(6,1) = {count} ;
                                        Attributes_4(7,1) = {count} ;
                                        Attributes_4(8,1) = {count} ;
                                        Col(1,1) = {Attributes_4} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,4) = {Col} ;
                                end
                                
                                Attributes_5(1,1) = {CV{s,3}/8} ;
                                Attributes_5(2,1) = {CV{s,3}/8} ;
                                Attributes_5(3,1) = {CV{s,3}/8} ;
                                Attributes_5(4,1) = {CV{s,3}/8} ;
                                Attributes_5(5,1) = {CV{s,3}/8} ;
                                Attributes_5(6,1) = {CV{s,3}/8} ;
                                Attributes_5(7,1) = {CV{s,3}/8} ;
                                Attributes_5(8,1) = {CV{s,3}/8} ;
                                Col(1,1) = {Attributes_5} ;
                                Col(1,2) = {qc} ;
                                Attributes(1,5) = {Col} ;
                                Attributes_9(1,1) = {{'time' , '00'}} ;
                                Attributes_9(2,1) = {{'time' , '03'}} ;
                                Attributes_9(3,1) = {{'time' , '06'}} ;
                                Attributes_9(4,1) = {{'time' , '09'}} ;
                                Attributes_9(5,1) = {{'time' , '12'}} ;
                                Attributes_9(6,1) = {{'time' , '15'}} ;
                                Attributes_9(7,1) = {{'time' , '18'}} ;
                                Attributes_9(8,1) = {{'time' , '21'}} ;
                                Col(1,1) = {Attributes_9} ;
                                Col(1,2) = {qc} ;
                                Attributes(1,9) = {Col} ;
                                
                                Defs.MARSAttributes = {'dataset','era20c' ; 'stream' ,stream ; 'format' ,'netcdf'  ; 'class'  ,'ei'  ; 'levtype',CV{s,7} ; 'type'   ,AF ; 'param'  ,CV{s,5} ; 'grid'   ,gridstr ; 'step' ,'0' } ;
                                Defs.MARSAttributes = [Defs.MARSAttributes ; {'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000'}] ;
                                
                            case 'Forecast'
                                Col = cell(1,2) ;
                                % Column 1: Date
                                Col(1,1) = {['Col = cell(',int2str(qc),',1) ; '  , ...
                                    'qf = 0 ; ' , ...
                                    'for y = ',int2str(First_Year),' : ',int2str(Last_Year),' ; ' , ...
                                    ' for m = 1:12 ; '  , ...
                                    '  for d = 1:GOAT_DaysInMonth(m,y)  ; ' , ...
                                    '   qf = qf+1 ; ' , ...
                                    '   daynum = int2str(y*10000 + m*100 + d) ; ' , ...
                                    '    Col(qf) = {daynum} ; ' , ...
                                    '  end ;  ' , ...
                                    ' end ;  ' , ...
                                    'end ; ']} ;
                                Col(1,2) = {'eval'} ;
                                Attributes(1,1) = {Col} ;
                                Col(1,1) = CV(s,1) ;
                                Col(1,2) = {qc} ;
                                Attributes(1,2) = {Col} ;
                                switch CV{s,7}
                                    case 'sfc' % lat,lon,time
                                        % Column 3: start
                                        Col(1,1) = {[1 1 1]} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,3) = {Col} ;
                                        % Column 4: count
                                        count = [inf inf 1] ;
                                        Col(1,1) = {count} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,4) = {Col} ;
                                    case 'pl' % lat lon level time
                                        Col(1,1) = {[1 1 1 1]} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,3) = {Col} ;
                                        % Column 4: count
                                        count = [inf inf inf 1] ;
                                        Col(1,1) = {count} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,4) = {Col} ;
                                end
                                if isequal(CV{s,3},h6) || isequal(CV{s,3},hp6)
                                    Attributes_5 = CV{s,3}*0.25 ;
                                else
                                    Attributes_5 = CV{s,3}*0.5 ;
                                end
                                Col(1,1) = {Attributes_5} ;
                                Col(1,2) = {qc} ;
                                Attributes(1,5) = {Col} ;
                                Col(1,1) = {{'time'   ,'00'}} ;
                                Col(1,2) = {qc} ;
                                Attributes(1,9) = {Col} ;
                                
                                Defs.MARSAttributes = {'dataset','era20c' ; 'stream' ,stream ; 'format' ,'netcdf'  ; 'class'  ,'ei'  ; 'levtype',CV{s,7} ; 'type'   ,AF ; 'param'  ,CV{s,5} ; 'grid'   ,gridstr ; 'step'   ,'24' } ;
                                Defs.MARSAttributes = [Defs.MARSAttributes ; {'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000'}] ;
                                
                        end
                    case 'DailyX4'
                        switch AFName
                            case 'Analysis'
                                Col = cell(1,2) ;
                                % Column 1: Date
                                Col(1,1) = {['Col = cell(',int2str(qc),',1) ; '  , ...
                                    'qf = 0 ; ' , ...
                                    'for y = ',int2str(First_Year),' : ',int2str(Last_Year),' ; ' , ...
                                    ' for m = 1:12 ; '  , ...
                                    '  for d = 1:GOAT_DaysInMonth(m,y)  ; ' , ...
                                    '       qf = qf+4 ; ' , ...
                                    '       Col(qf-3:qf) = {int2str(y*10000 + m*100 + d)} ; ' , ...
                                    '  end ;  ' , ...
                                    ' end ;  ' , ...
                                    'end ; ']} ;
                                Col(1,2) = {'eval'} ;
                                Attributes(1,1) = {Col} ;
                                Col(1,1) = CV(s,1) ;
                                Col(1,2) = {qc} ;
                                Attributes(1,2) = {Col} ;
                                switch CV{s,7}
                                    case 'sfc' % lat,lon,time
                                        % Column 3: start
                                        Col(1,1) = {[1 1 1]} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,3) = {Col} ;
                                        % Column 4: count
                                        count = [inf inf 1] ;
                                        Col(1,1) = {count} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,4) = {Col} ;
                                    case 'pl' % lat lon level time
                                        Col(1,1) = {[1 1 1 1]} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,3) = {Col} ;
                                        % Column 4: count
                                        count = [inf inf inf 1] ;
                                        Col(1,1) = {count} ;
                                        Col(1,2) = {qc} ;
                                        Attributes(1,4) = {Col} ;
                                end
                                Col(1,1) = CV(s,3) ;
                                Col(1,2) = {qc} ;
                                Attributes(1,5) = {Col} ;
                                Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                    'Col(1:4:end,1) = {{''time'' , ''00''}} ; ' , ...
                                    'Col(2:4:end,1) = {{''time'' ,''06''}} ; ' , ...
                                    'Col(3:4:end,1) = {{''time'' ,''12''}} ; ' , ...
                                    'Col(4:4:end,1) = {{''time'' ,''18''}} ; ' ]} ;
                                Col(1,2) = {'eval'} ;
                                Attributes(1,9) = {Col} ;
                                Defs.MARSAttributes = {'dataset','era20c' ; 'stream' ,stream ; 'format' ,'netcdf'  ; 'class'  ,'ei'  ; 'levtype',CV{s,7} ; 'type'   ,AF ; 'param'  ,CV{s,5} ; 'grid'   ,gridstr ; 'step'   ,'0'} ;
                                
                                Defs.MARSAttributes = [Defs.MARSAttributes ; {'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000'}] ;
                                
                            case 'Forecast'
                                Col = cell(1,2) ;
                                if isequal(CV{s,3},h6) || isequal(CV{s,3},hp6) % cumulative fields
                                    
                                    % Column 1: Date
                                    Col(1,1) = {['Col = cell(',int2str(qc),',1) ; '  , ...
                                        'qf = 0 ; ' , ...
                                        'for y = ',int2str(First_Year),' : ',int2str(Last_Year),' ; ' , ...
                                        ' for m = 1:12 ; '  , ...
                                        '  for d = 1:GOAT_DaysInMonth(m,y)  ; ' , ...
                                        '       daynum = int2str(y*10000 + m*100 + d) ; ' , ...
                                        '       qf = qf+1 ; ' , ...
                                        '       Col(qf) = {daynum} ; ' , ...
                                        '       qf = qf+1 ; ' , ...
                                        '       Col(qf) = {{daynum ; daynum}} ; ' , ...
                                        '       qf = qf+1 ; ' , ...
                                        '       Col(qf) = {daynum} ; ' , ...
                                        '       qf = qf+1 ; ' , ...
                                        '       Col(qf) = {{daynum ; daynum}} ; ' , ...
                                        '  end ;  ' , ...
                                        ' end ;  ' , ...
                                        'end ; ']} ;
                                    Col(1,2) = {'eval'} ;
                                    Attributes(1,1) = {Col} ;
                                    
                                    Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                        'Col(1:2:end,1) = {''',CV{s,1},'''} ; ' , ...
                                        'Col(2:2:end,1) = {{''',CV{s,1},''' ; ''',CV{s,1},'''}} ; ' ]} ;
                                    Col(1,2) = {'eval'} ;
                                    Attributes(1,2) = {Col} ;
                                    switch CV{s,7}
                                        case 'sfc' % lat,lon,time
                                            % Column 3: start
                                            Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                                'Col(1:2:end,1) = {[1 1 1]} ; ' , ...
                                                'Col(2:2:end,1) = {{[1 1 1] ; [1 1 1]}} ; ' ]} ;
                                            Col(1,2) = {'eval'} ;
                                            Attributes(1,3) = {Col} ;
                                            % Column 4: count
                                            Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                                'Col(1:2:end,1) = {[inf inf 1]} ; ' , ...
                                                'Col(2:2:end,1) = {{[inf inf 1] ; [inf inf 1]}} ; ' ]} ;
                                            Col(1,2) = {'eval'} ;
                                            Attributes(1,4) = {Col} ;
                                        case 'pl' % lat lon level time
                                            Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                                'Col(1:2:end,1) = {[1 1 1 1]} ; ' , ...
                                                'Col(2:2:end,1) = {{[1 1 1 1] ; [1 1 1 1]}} ; ']} ;
                                            Col(1,2) = {'eval'} ;
                                            Attributes(1,3) = {Col} ;
                                            % Column 4: count
                                            Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                                'Col(1:2:end,1) = {[inf inf inf 1]} ; ' , ...
                                                'Col(2:2:end,1) = {{[inf inf inf 1] ; [inf inf inf 1]}} ; '  ]} ;
                                            Col(1,2) = {'eval'} ;
                                            Attributes(1,4) = {Col} ;
                                    end
                                    Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                        'Col(1:2:end,1) = {',num2str(CV{s,3}),'} ; ' , ...
                                        'Col(2:2:end,1) = {{',num2str(-CV{s,3}),' ; ',num2str(CV{s,3}),'}} ; ' ]} ;
                                    Col(1,2) = {'eval'} ;
                                    Attributes(1,5) = {Col} ;
                                    
                                    Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                        'Col(1:4:end,1) = {{''time'' ,''00'' ; ''step'' , ''6''}} ; ' , ...
                                        'Col1 = cell(2,1)  ; ' , ...
                                        'Col1(1,1) = {{''time'' ,''00'' ; ''step'' , ''06''}} ; ' , ...
                                        'Col1(2,1) = {{''time'' ,''00'' ; ''step'' , ''12''}} ; ' , ...
                                        'Col(2:4:end,1)  = {Col1} ; ' , ...
                                        'Col(3:4:end,1) = {{''time'' ,''12'' ; ''step'' , ''6''}} ; ' , ...
                                        'Col1(1,1) = {{''time'' ,''12'' ; ''step'' , ''06''}} ; ' , ...
                                        'Col1(2,1) = {{''time'' ,''12'' ; ''step'' , ''12''}} ; ' , ...
                                        'Col(4:4:end,1) = {Col1} ; ' ]} ;
                                    Col(1,2) = {'eval'} ;
                                    Attributes(1,9) = {Col} ;
                                else % Non-cumulative Forecast fields
                                    % Column 1: Date
                                    Col(1,1) = {['Col = cell(',int2str(qc),',1) ; '  , ...
                                        'qf = 0 ; ' , ...
                                        'for y = ',int2str(First_Year),' : ',int2str(Last_Year),' ; ' , ...
                                        ' for m = 1:12 ; '  , ...
                                        '  for d = 1:GOAT_DaysInMonth(m,y)  ; ' , ...
                                        '       daynum = int2str(y*10000 + m*100 + d) ; ' , ...
                                        '       qf = qf+4 ; ' , ...
                                        '       Col(qf-3:qf) = {daynum} ; ' , ...
                                        '  end ;  ' , ...
                                        ' end ;  ' , ...
                                        'end ; ']} ;
                                    Col(1,2) = {'eval'} ;
                                    Attributes(1,1) = {Col} ;
                                    
                                    Col(1,1) = CV(s,1) ;
                                    Col(1,2) = {qc} ;
                                    Attributes(1,2) = {Col} ;
                                    switch CV{s,7}
                                        case 'sfc' % lat,lon,time
                                            % Column 3: start
                                            Col(1,1) = {[1 1 1]} ;
                                            Col(1,2)  = {qc} ;
                                            Attributes(1,3) = {Col} ;
                                            % Column 4: count
                                            Col(1,1) = {[inf inf 1]} ;
                                            Col(1,2) = {qc} ;
                                            Attributes(1,4) = {Col} ;
                                        case 'pl' % lat lon level time
                                            Col(1,1) = {[1 1 1 1]} ;
                                            Col(1,2) = {qc} ;
                                            Attributes(1,3) = {Col} ;
                                            % Column 4: count
                                            Col(1,1) = {[inf inf inf 1]} ;
                                            Col(1,2) = {qc} ;
                                            Attributes(1,4) = {Col} ;
                                    end
                                    Col(1,1) = CV(s,3) ;
                                    Col(1,2) = {qc} ;
                                    Attributes(1,5) = {Col} ;
                                    
                                    Col(1,1) = {['Col = cell(',int2str(qc),',1) ; ' , ...
                                        'Col(1:4:end,1) = {{''time'' ,''00'' ; ''step'' , ''6''}} ; ' , ...
                                        'Col(2:4:end,1) = {{''time'' ,''00'' ; ''step'' , ''12''}} ; ' , ...
                                        'Col(3:4:end,1) = {{''time'' ,''12'' ; ''step'' , ''6''}} ; ' , ...
                                        'Col(4:4:end,1) = {{''time'' ,''12'' ; ''step'' , ''12''}} ; ' ]} ;
                                    Col(1,2) = {'eval'} ;
                                    Attributes(1,9) = {Col} ;
                                end
                                Defs.MARSAttributes = {'dataset','era20c' ; 'stream' ,stream ; 'format' ,'netcdf'  ; 'class'  ,'ei'  ; 'levtype',CV{s,7} ; 'type'   ,AF ; 'param'  ,CV{s,5} ; 'grid'   ,gridstr } ;
                                
                                Defs.MARSAttributes = [Defs.MARSAttributes ; {'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000'}] ;
                        end
                end
                
                Attributes(end,1) = {Ext} ; % 'eri'
                Attributes(end,2) = {[First_Year Last_Year]} ;
                Attributes(end,3) = {Defs} ; % Defs Struct
                Attributes(end,4) = {Calendar} ;
                
                %Attributes_check = GOAT_ALP_CompressAttributes(Attributes) ;
                
                save(fullfile(Data_LINK,FieldName,'link_field.mat'),'Attributes') ;
                J = 1 ; clear Text 
                Text(J,1) = {['GOAT variable name = ',FieldName]} ; J = J + 1 ; 
                Text(J,1) = {['NetCDF variable name = ',CV{s,1}]} ; J = J + 1 ; 
                Text(J,1) = {['First Year = ',int2str(First_Year)]} ; J = J + 1 ; 
                Text(J,1) = {['Last Year = ',int2str(Last_Year)]} ; J = J + 1 ; 
                Text(J,1) = {['Calendar = ',Calendar]} ; J = J + 1 ; 
                Text(J,1) = {['Field Description = ',FieldDescription]} ; J = J + 1 ; 
                Text(J,1) = {['Units = ',Units]} ; J = J + 1 ; 
                Text(J,1) = {['LINK Type = ',Ext]} ; J = J + 1 ; 
                GOAT_cell2txt(fullfile(Data_LINK,FieldName,'link_info.txt'),Text) ;
                if strcmp(FieldName,'ps')
                    if ~exist(fullfile(Data_LINK,'BoerBeta'),'dir') ;
                        mkdir(fullfile(Data_LINK,'BoerBeta')) ;
                    end
                    Attributes(end,1) = {'ers'} ;
                    save(fullfile(Data_LINK,'BoerBeta','link_field.mat'),'Attributes') ;
                    FieldDescription = 'Boer Beta Function' ;
                    Units = '1' ;
                    Text(1,1) = {['GOAT variable name = BoerBeta']} ; 
                    Text(end-2,1) = {['Field Description = ',FieldDescription]} ;  
                    Text(end-1,1) = {['Units = ',Units]} ;  
                    Text(end,1) = {['LINK Type = ers']} ;  
                    GOAT_cell2txt(fullfile(Data_LINK,'BoerBeta','link_info.txt'),Text) ;
                    
                    try
                        P = P15 ;
                        save(fullfile(Data_LINK,'BoerBeta','Dims.mat'),'P','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
                    catch
                        % 2D dataset Boer Beta is a place holder for other 3D datasets
                    end
                    
                end
            end % s
            
            TT = toc ;
            totaltoc = totaltoc + TT ;
            HH = floor(TT/3600) ;
            MM = floor((TT - HH*3600)/60) ;
            SS = TT - HH*3600 - MM*60 ;
            if HH > 0
                TimeString = [int2str(HH),' hours, ',int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
            elseif MM > 0
                TimeString = [int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
            elseif SS > 0
                TimeString = [int2str(SS),' seconds.'] ;
            end
            disp(['Linking Monthly ERA-20C ',Calendar,' / ',AFName,' / resolution ',gridstr,' completed in ',TimeString]) ;
        end % ana
    end % cal
end % res


TT = totaltoc ;
HH = floor(TT/3600) ;
MM = floor((TT - HH*3600)/60) ;
SS = TT - HH*3600 - MM*60 ;
if HH > 0
    TimeString = [int2str(HH),' hours, ',int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
elseif MM > 0
    TimeString = [int2str(MM),' minutes and ',int2str(SS),' seconds.'] ;
elseif SS > 0
    TimeString = [int2str(SS),' seconds.'] ;
end
disp(['Linking Monthly ERA-20C via MARS API completed in ',TimeString]) ;







% Invariant Fields

CV = cell(1,8) ; qV = 1 ;
[CV(qV,:)] = deal([{'name'}    ,{'std_name'},{'Fctr'},{'Units'}     ,{'param'},{'A'},{'pl'} ,{'Description'}])                                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'anor'}    ,{'anor'}    ,{1}     ,{'radians'}   ,{'162.128'},{1},{'sfc'},{'Angle of sub-gridscale orography'}])               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'z'}       ,{'zgs'}     ,{1/9.80616},{'m'}      ,{'129.128'},{1},{'sfc'},{'Surface geopotential height'}])                    ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'lsm'}     ,{'landseamask'},{1}  ,{'0/1'}       ,{'172.128'},{1},{'sfc'},{'Land-sea mask'}])                                  ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'slor'}    ,{'slor'}    ,{1}     ,{'Unknown'}   ,{'163.128'},{1},{'sfc'},{'Slope of sub-gridscale orography'}])               ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sdor'}    ,{'sdor'}    ,{1}     ,{'Unknown'}   ,{'160.128'},{1},{'sfc'},{'Standard deviation of orography'}])                ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'tvl'}     ,{'tvl'}     ,{1}     ,{'Unknown'}   ,{'29.128'} ,{0},{'sfc'},{'Type of low vegetation'}])                         ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'isor'}    ,{'isor'}    ,{1}     ,{'Unknown'}   ,{'161.128'},{0},{'sfc'},{'Anisotropy of sub-gridscale orography'}])          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'cvh'}     ,{'cvh'}     ,{1}     ,{'0-1'}       ,{'28.128'} ,{0},{'sfc'},{'High vegetation cover'}])                          ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'cvl'}     ,{'cvl'}     ,{1}     ,{'0-1'}       ,{'27.128'} ,{0},{'sfc'},{'Low vegetation cover'}])                           ; qV = qV + 1 ;
[CV(qV,:)] = deal([{'sdfor'}   ,{'sdfor'}   ,{1}     ,{'m'}         ,{'74.128'} ,{0},{'sfc'},{'Standard deviation of filtered subgrid orography'}]); qV = qV + 1 ;
[CV(qV,:)] = deal([{'tvh'}     ,{'tvh'}     ,{1}     ,{'Unknown'}   ,{'30.128'} ,{0},{'sfc'},{'Type of high vegetation'}])                        ; qV = qV + 1 ;

Calendar = 'List' ;
Ext = 'eri' ;
longitude_dimname = 'longitude' ;
latitude_dimname  = 'latitude' ;
level_dimname     = 'level' ;
time_dimname      = 'time';
First_Year = 1900 ;
First_Month = 1 ;
First_Day = 1 ;
First_Hour = 0 ;
Last_Year = 2010 ;
Last_Month = 12 ;
Last_Day = 31 ;
Last_Hour = 21 ;
%
load(fullfile(fileparts(which('GOAT.m')),'Utils','DataManagementCode','ECMWF','DimsERAI.mat')) ;

for res = 1:2
    for s = 2:size(CV,1)
        param = CV{s,5} ;
        stream = 'moda' ;
        AFName = 'Analysis' ;
        AF = 'an' ;

        switch res
            case 1
                Data_LINK = fullfile(Data_ALP,'ERA20C_LINK','1_5X1_5',AFName,Calendar) ;
                lon = lon15 ;
                lat = lat15 ;
                gridstr = '1.5/1.5' ;
            case 2
                Data_LINK = fullfile(Data_ALP,'ERA20C_LINK','0_75X0_75',AFName,Calendar) ;
                lon = lon75 ;
                lat = lat75 ;
                gridstr = '0.75/0.75' ;
        end
        infostr = sprintf(['Invariants, ',AFName,' fields at ',gridstr,' degree spatial resolution.', ...
            '\nAbout ERA-20C (source: UCAR Climate Data Guide):', ...
            '\nERA-20C is ECMWF''s first atmospheric reanalysis of the 20th century, from 1900-2010. ', ...
            '\nIt assimilates observations of surface pressure and surface marine winds only. ', ... 
            '\nA coupled Atmosphere/Land-surface/Ocean-waves model is used to reanalyse the weather, by assimilating surface observations. ', ...
            '\nThe ERA-20C products describe the spatio-temporal evolution of the atmosphere (on 91 vertical levels, between the surface and 0.01 hPa), ', ...
            '\nthe land-surface (on 4 soil layers), and the ocean waves (on 25 frequencies and 12 directions).', ...
            '\nThe horizontal resolution is approximately 125 km (spectral truncation T159). Note, atmospheric data are not only available on the native 91 model levels, ', ...
            '\nbut also on 37 pressure levels (as in ERA-Interim), 16 potential temperature levels, and the 2 PVU potential vorticity level.' , ...
            '\nThe assimilation methodology is 24-hour 4D-Var analysis, with variational bias correction of surface pressure observations. ', ...
            '\nAnalysis increments are at T95 horizontal resolution (aprox. 210 km). The analyses provide the initial conditions for subsequent forecasts ', ...
            '\nthat serve as backgrounds to the next analyses. The spatio-temporal evolution of background errors was provided by a 10-member ensemble produced a priori  (Poli et al. (2013)).', ...
            '\nThe observations assimilated in ERA-20C include surface and mean sea level pressures from ISPDv3.2.6 and ICOADSv2.5.1, and surface marine winds from ICOADSv2.5.1. ']) ;
        
        
        if ~exist(Data_LINK,'dir')
            mkdir(Data_LINK) ;
        end
        save(fullfile(Data_LINK,'info.mat'),'infostr')
        VerticalOrdinate = 'Pressure (mb)' ;
        
        GOAT_Display_message(G,'','init')
        FieldName = CV{s,2} ;
        disp(['linking ',gridstr,'  ',Calendar,' ',AFName,'  ',FieldName,'  ',int2str(s-1),'/',int2str(size(CV,1)),'  . . . '])
        mkdir(fullfile(Data_LINK,FieldName)) ;
        %VerticalOrdinate =
        Units            = CV{s,4} ;
        FieldDescription = CV{s,8} ;
        % retrieve spatial vectors
        if strncmp(CV{s,7},'s',1)
            P = 1000 ;
        else
            P = P15 ;
        end
        
        save(fullfile(Data_LINK,FieldName,'Dims.mat'),'P','lon','lat','Units','VerticalOrdinate','FieldDescription') ;
        Attributes = cell(2,5) ;
        
        Attributes(1,1) = {'19890101'}  ;
        Attributes(1,2) = CV(s,1)       ;
        Attributes(1,3) = {[1 1 1]}     ;
        Attributes(1,4) = {[inf inf 1]} ;
        Attributes(1,5) = CV(s,3)       ;
        Attributes(1,10) = CV(s,8)       ;
        Defs.MARSAttributes = {'dataset','era20c' ; ...
            'stream' ,'moda' ; ...
            'format' ,'netcdf'  ; ...
            'class'  ,'ei'      ; ...
            'levtype',CV{s,7} ; ...
            'time'   ,'12' ; ...
            'step'   ,'0' ; ...
            'type'   ,AF ; ...
            'param'  ,CV{s,5} ; ...
            'grid'   ,gridstr } ;
        if strcmpi(CV{s,7},'pl')
            Defs.MARSAttributes = [Defs.MARSAttributes ; {'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000'}] ;
        end
        Attributes(end,1) = {Ext} ; % 'mat' | 'ncf' | 'dap' | 'gb1' | 'gb2'
        Attributes(end,2) = {[First_Year Last_Year]} ;
        Attributes(end,3) = {Defs} ; % Defs Struct
        Attributes(end,4) = {Calendar} ;
        mkdir(fullfile(Data_LINK,FieldName,'Invariant')) ;
        save(fullfile(Data_LINK,FieldName,'Invariant','link_field.mat'),'Attributes') ;
        J = 1 ; clear Text 
        Text(J,1) = {['GOAT variable name = ',FieldName]} ; J = J + 1 ; 
        Text(J,1) = {['NetCDF variable name = ',CV{s,1}]} ; J = J + 1 ; 
        Text(J,1) = {['First Year = ',int2str(First_Year)]} ; J = J + 1 ; 
        Text(J,1) = {['Last Year = ',int2str(Last_Year)]} ; J = J + 1 ; 
        Text(J,1) = {['Calendar = ',Calendar]} ; J = J + 1 ; 
        Text(J,1) = {['Field Description = ',FieldDescription]} ; J = J + 1 ; 
        Text(J,1) = {['Units = ',Units]} ; J = J + 1 ; 
        Text(J,1) = {['LINK Type = ',Ext]} ; J = J + 1 ; 
        GOAT_cell2txt(fullfile(Data_LINK,FieldName,'Invariant','link_info.txt'),Text) ;
    end
end

disp 'linking ERA-20C Invariant fields complete.'




%% validate field MARS retrieve attributes

% VarIdx = 4 ;
% attributes = {'dataset','interim' ; ...
%  'stream' ,'moda' ; ...
%  'format' ,'netcdf'  ; ...
%  'class'  ,'ei'      ; ...
%  'levtype','sfc' ; ...
%  'date'   ,'19790101'; ...
%  'type'   ,'an' ; ...
%  'grid'   ,'1.5/1.5' ; ...
%  'target' ,'data.nc' ; ...
%  'param'  ,'248.128'  ...
% } ;

% VarIdx = 4 ;
% attributes = {'dataset','era20c' ; ...
%     'stream' ,'moda' ; ...
%     'format' ,'netcdf'  ; ...
%     'class'  ,'ei'      ; ...
%     'levtype','pl' ; ...
%     'date'   ,'19000101'; ...
%     'type'   ,'an' ; ...
%     'grid'   ,'1.5/1.5' ; ...
%     'target' ,'data.nc' ; ...
%     'time'   ,'12'      ; ...
%     'step'   ,'0'      ; ...
%     'type'   ,'an' ; ...
%     'param'  ,'130.128'  ...
%     } ;

% VarIdx = 5 ;
% attributes = {'dataset','era20c' ; ...
%     'stream' ,'moda' ; ...
%     'format' ,'netcdf'  ; ...
%     'class'  ,'ei'      ; ...
%     'levtype','pl' ; ...
%     'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000' ; ...
%     'date'   ,'19790101'; ...
%     'type'   ,'an' ; ...
%     'grid'   ,'1.5/1.5' ; ...
%     'target' ,'data.nc' ; ...
%     'param'  ,'130.128'  ...
%     } ;


VarIdx = 4 ;
attributes = {'dataset','era20c' ; ...
    'stream' ,'moda' ; ...
    'format' ,'netcdf'  ; ...
    'class'  ,'ei'      ; ...
    'levtype','sfc' ; ...
    'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000' ; ...
    'date'   ,'19000101'; ...
    'type'   ,'fc' ; ...
    'grid'   ,'1.5/1.5' ; ...
    'target' ,'data.nc' ; ...
    'param'  ,'228.128' ; ...
    'time'   ,'00'      ; ...
    'step'   ,'24'      ... 
    } ;

delete('data.nc')
perl(GOAT_ERA_MARS_retrieve2perl(attributes)) ;
a = ncinfo('data.nc') ;
disp ' '
disp(['varname = ',a.Variables(VarIdx).Name])
for i = 1:length(a.Variables(VarIdx).Attributes)
    disp([a.Variables(VarIdx).Attributes(i).Name,' == ',a.Variables(VarIdx).Attributes(i).Value]) ;
end













