% GOAT_ERA_MARS_retrieve2perl :  Produce perl script for retrieving data from the ECMWF MARS server
% syntax:
% >> plscript = GOAT_ERA_MARS_retrieve2perl(attributes)
% attributes is a Nx2 cell array of N pairs of MARS batch attributes
%


function perlscript = GOAT_ERA_MARS_retrieve2perl(attributes,OutputAddress)
if nargin > 1
perlscript = OutputAddress ; 
else
perlscript = fullfile(fileparts(fileparts(which('GOAT.m'))),'Downloads','temp','era_batch.pl') ; 
end
api_address = fullfile(fileparts(which('GOAT.m')),'Utils','DataManagementCode','ECMWF','ecmwf-api-client-perl','') ; 
Text = cell(1,1) ; J = 1 ; 
Text(J,1) = {'#!/usr/bin/env perl'            } ; J = J + 1 ; 
Text(J,1) = {' '                              } ; J = J + 1 ; 
Text(J,1) = {['use lib ''',api_address,''' ; ']} ; J = J + 1 ; 
Text(J,1) = {' '                              } ; J = J + 1 ; 
Text(J,1) = {'BEGIN { $ENV{PERL_LWP_SSL_VERIFY_HOSTNAME} = 0 }'} ; J = J + 1 ; 
Text(J,1) = {' '                              } ; J = J + 1 ; 
Text(J,1) = {'use ECMWF::DataServer; '        } ; J = J + 1 ; 
Text(J,1) = {' '                              } ; J = J + 1 ; 
Text(J,1) = {'my $client = ECMWF::DataServer->new(); '} ; J = J + 1 ; 
Text(J,1) = {' '                              } ; J = J + 1 ; 
Text(J,1) = {'$client->retrieve( '                              } ; J = J + 1 ; 
for i = 1:size(attributes,1)
Text(J,1) = {['   ',attributes{i,1},'  =>"',attributes{i,2},'",']} ; J = J + 1 ; 
end
Text(J,1) = {'    );'                              } ; J = J + 1 ; 
Text(J,1) = {' '                              } ; 

GOAT_cell2txt(perlscript,Text) ;
%% attributes examples
%{
attributes = {'dataset','interim' ; ...
 'format' ,'netcdf'  ; ...
 'step'   ,'06'      ; ...
 'levtype','pressure levels' ; ...
 'date'   ,'20071001'; ...
 'time'   ,'00'      ; ... 
 'type'   ,'forecast' ; ...
 'param'  ,'temperature' ; ...
 'grid'   ,'1.5/1.5' ; ...
 'target' ,'data.nc' ...
}



attributes = {'dataset','interim' ; ...
 'stream' ,'moda' ; ...
 'format' ,'netcdf'  ; ...
 'class'  ,'ei'      ; ...
 'levtype','sfc' ; ...
 'date'   ,'19790101'; ...
 'type'   ,'an' ; ...
 'grid'   ,'1.5/1.5' ; ...
 'target' ,'data.nc' ; ...
 'param'  ,'165.128'  ...
}


attributes = {'dataset','interim' ; ...
 'stream' ,'moda' ; ...
 'format' ,'netcdf'  ; ...
 'class'  ,'ei'      ; ...
 'levtype','pl'      ; ...
 'levelist','1/2/3/5/7/10/20/30/50/70/100/125/150/175/200/225/250/300/350/400/450/500/550/600/650/700/750/775/800/825/850/875/900/925/950/975/1000' ; ...
'date'   ,'19790101'; ...
 'type'   ,'an' ; ...
 'param'  ,'129.128' ; ...
 'grid'   ,'0.75/0.75' ; ...
 'target' ,'data.nc' ...
}



%}
