% Convert GISTEMP
gunzip('http://data.giss.nasa.gov/pub/gistemp/gistemp250.nc.gz') ; 
%
Data = GOAT_nc2mat('gistemp250.nc') ; 
year0 = 1880 ; FieldName = 'Land' ; 
DataFolder = '/Volumes/data1/Ori/GOAT/Data/GISTEMP' ;  
mkdir(DataFolder) ; 
mkdir(fullfile(DataFolder,'Monthly')) ;
mkdir(fullfile(DataFolder,'Monthly',FieldName)) ;
P = 1000 ; 
lon = Data.lon ; 
lat = Data.lat ; 
VerticalOrdinate = 'Pressure (mb)' ; 
FieldDescription = 'GISTEMP land temperature anomaly (relative to 1951-1980). 250km smoothing.' ; 
Units = 'K' ; 
save(fullfile(DataFolder,'Monthly',FieldName,'Dims.mat'),'lat','lon','P','Units','VerticalOrdinate','FieldDescription') ; 
q = 0 ;
for y = year0:year0 + floor(size(Data.var1,3)/12)
    mkdir(fullfile(DataFolder,'Monthly',FieldName,int2str(y))) ; 
    for m = 1:12
        q = q+1 ; 
        try
        data = squeeze(Data.var1(:,:,q)) ; 
        data(data > 300) = nan ; 
        save(fullfile(DataFolder,'Monthly',FieldName,int2str(y),[int2str(m*10000),'.mat']),'data') ; 
        catch
          %  nevermind, missing endyear files
        end
    end
end
%
delete('gistemp250.nc') ; 
FieldName = 'LandOcean' ; 
gunzip('http://data.giss.nasa.gov/pub/gistemp/gistemp1200_ERSST.nc.gz') ; 
Data = GOAT_nc2mat('gistemp1200_ERSST.nc') ; 
mkdir(fullfile(DataFolder,'Monthly',FieldName)) ;
%
P = 1000 ; 
lon = Data.lon ; 
lat = Data.lat ; 
FieldDescription = 'GISTEMP land (+ERSST Ocean) temperature anomaly (relative to 1951-1980). 1200km smoothing.' ; 
save(fullfile(DataFolder,'Monthly',FieldName,'Dims.mat'),'lat','lon','P','Units','VerticalOrdinate','FieldDescription') ; 
q = 0 ;
for y = year0:year0 + floor(size(Data.var1,3)/12)
    mkdir(fullfile(DataFolder,'Monthly',FieldName,int2str(y))) ; 
    for m = 1:12
        q = q+1 ; 
        try
        data = squeeze(Data.var1(:,:,q)) ; 
        data(data > 300) = nan ; 
        save(fullfile(DataFolder,'Monthly',FieldName,int2str(y),[int2str(m*10000),'.mat']),'data') ; 
        catch
          %  nevermind, missing endyear files
        end
    end
end

delete('gistemp1200_ERSST.nc') ; 