% ONI Index to GOAT MAT format
%
% Copy and pase the contents of the ONI values table given in
% 'http://www.cpc.ncep.noaa.gov/products/analysis_monitoring/ensostuff/ensoyears.shtml'
% into a cell(1,1) array named ONI0

IndexRoot = '/Users/oradam/Documents/MATLAB/GOAT/Data/Indices/Monthly/ONI/' ;
Units = 'K' ;
FieldDescription = 'Oceanic Nino Index (www.cpc.ncep.noaa.gov)' ;
VerticalOrdinate = 'Pressure (mb)' ;
lon = 1 ;
lat = 1 ;
lev = 1 ;


ONI = cell2mat(ONI0(~cellfun(@isempty,ONI0))) ;

YearsIdx = 1:13:length(ONI) ;
Years = ONI(YearsIdx) ;
FirstYear = Years(1) ;
LastYear  = Years(end) ;
ONI(YearsIdx)  = nan ;
ONI = ONI(~isnan(ONI)) ;

Addresses = GOAT_AddressesStrings(FirstYear,LastYear,'Monthly') ;

save(fullfile(IndexRoot,'Dims.mat'),'lon','lat','lev','Units','FieldDescription','VerticalOrdinate') ;

for i = 1:length(ONI)
    data = ONI(i) ;
    fileaddress = fullfile(IndexRoot,Addresses{i}) ;
    if ~exist(fileparts(fileaddress),'dir')
        mkdir(fileparts(fileaddress))
    end
    save(fullfile(IndexRoot,Addresses{i}),'data') ;
end

disp 'ONI Index Update complete' ;



