%% Download MEI Idx
MEIIdxURL = 'http://www.esrl.noaa.gov/psd/data/correlation/mei.data' ; 
DataFileName = 'MEIdata.data' ; 
urlwrite(MEIIdxURL,DataFileName) ;
DataStruct = importdata(DataFileName) ; 
delete(DataFileName) ; 
%% Index vector
Data = DataStruct.data(1:end-1,2:end)' ; 
MEI.DataTimeLine = Data(:) ; 
ValidData = find(MEI.DataTimeLine>-900) ; 
MEI.DataTimeLine = MEI.DataTimeLine(ValidData) ; 
%% years
MEI.years = DataStruct.data(1:end-1,1) ;
MEI.TimeContinuos = linspace(MEI.years(1),MEI.years(end)+1,12*length(MEI.years)) ; 
MEI.TimeContinuos = MEI.TimeContinuos(ValidData) ; 
%% dates strings
MEI.dates = cell(12*length(MEI.years),1) ;
year = MEI.years(1) - 1 ; 
for i = 1:12*length(MEI.years);
    if mod(i,12) == 1 ; year = year + 1 ; end
    switch mod(i,12)
        case 1
            month = 'Jan' ;
        case 2
            month = 'Feb' ;
        case 3
            month = 'Mar' ;
        case 4
            month = 'Apr' ;
        case 5
            month = 'May' ;
        case 6
            month = 'Jun' ;
        case 7
            month = 'Jul' ;
        case 8
            month = 'Aug' ;
        case 9
            month = 'Sep' ;
        case 10
            month = 'Oct' ;
        case 11
            month = 'Nov' ;
        case 0
            month = 'Dec' ;
    end
    MEI.dates(i) = {[int2str(year),'.',month]} ; 
end
%% Figure
MEI.NinoIdx = find(MEI.DataTimeLine>=0) ;   
MEI.NinaIdx = find(MEI.DataTimeLine<0)  ; 
MaxIdx = max(abs(MEI.DataTimeLine)) ; 
Fig = figure ;
hr = bar(MEI.TimeContinuos(MEI.NinoIdx),MEI.DataTimeLine(MEI.NinoIdx),'r','edgecolor','none') ; hold on ; 
hb = bar(MEI.TimeContinuos(MEI.NinaIdx),MEI.DataTimeLine(MEI.NinaIdx),'b','edgecolor','none') ;  
text(MEI.TimeContinuos(1)+(MEI.TimeContinuos(end)-MEI.TimeContinuos(1))*0.05,MaxIdx*.96,'\bfEl Nino','fontsize',16) ; 
text(MEI.TimeContinuos(1)+(MEI.TimeContinuos(end)-MEI.TimeContinuos(1))*0.05,-MaxIdx*.96,'\bfLa Nina','fontsize',16) ; 
hold off ;
br = get(hr,'baseline') ; delete(br) ; 
set(gca,'box','off','fontsize',12) ; 
xlim([MEI.TimeContinuos(1) MEI.TimeContinuos(end)])
ylim([-1.1*MaxIdx 1.1*MaxIdx]) ;
title('\bfMultiVariate ENSO Index (MEI)','fontsize',14)
xlabel('\bfYear','fontsize',14) ; 
ylabel('\bfMEI','fontsize',14)
%% Save Data
save('MEI.mat','MEI') ;
saveas(Fig,'MEI.fig') ; 