% BoerBeta


Span = 'all'     ;
%Span = 2009:2011 ; % By pass for specific years. Comment to cancel Bypass.
FieldDir = uigetdir ;
FieldPath = fileparts(FieldDir) ;
SurfPDir = fullfile(FieldPath,'ps','') ;
load(fullfile(SurfPDir,'Dims.mat')) ;
LatP = lat ;
LonP = lon ;
BoerDir = fullfile(FieldPath,'BoerBeta','') ;
load(fullfile(FieldDir,'Dims.mat')) ;
mkdir(BoerDir) ;
FieldDescription = 'Boer Beta function: 0 for P > Surface P  |  1 for P < SurfP'  ;
Units = '1' ;
VerticalOrdinate = 'Pressure (mb)' ;
save(fullfile(BoerDir,'Dims.mat'),'lon','lat','P','Units','FieldDescription','VerticalOrdinate') ;
O = ones(length(lon), length(lat), length(P)) ; 
Pmat = repmat(reshape(P,1,1,length(P)),[length(lon) length(lat) 1])*100    ;
if isequal(LatP,lat) && isequal(LonP,lon)
    InterpPFlag = 0 ;
else
    InterpPFlag = 1 ;
end


if strcmp(Span,'all')
    yearsdir = dir(FieldDir) ;
    Ny = 0 ;
    years = [] ;
    for j = 1:length(yearsdir)
        if yearsdir(j,1).isdir && ...
                ~strncmp(yearsdir(j,1).name,'.',1)
            Ny = Ny + 1 ;
            years(Ny) = round(str2double(yearsdir(j,1).name)) ;
        end
    end
    Pyearsdir = dir(SurfPDir) ;
    Ny = 0 ;
    Pyears = [] ;
    for j = 1:length(Pyearsdir)
        if Pyearsdir(j,1).isdir && ...
                ~strncmp(Pyearsdir(j,1).name,'.',1)
            Ny = Ny + 1 ;
            Pyears(Ny) = round(str2double(Pyearsdir(j,1).name)) ;
        end
    end
    y1 = max([min(years),min(Pyears)]) ;
    y2 = min([max(years),max(Pyears)]) ;
else
    y1 = Span(1) ;
    y2 = Span(end) ;
end
tic ;
q =0 ;
for y = y1:y2
    for m = 1:12
        for d = 1:32
            for h = 1:24
                try
                    load(fullfile(FieldDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat'])) ;
                    data0 = data ;
                    load(fullfile(SurfPDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat'])) ;
                    dataP = data ;
                    % If SurfP and Field file exist interpolate to Sigma Levels
                    % First Interpolate Surface Pressure if necessary
                    if InterpPFlag
                        dataP2 = interp2(LatP,LonP,dataP,lat,lon') ;
                    end
                    SurfPmat = repmat(dataP2,[1 1 length(P)]) ;
                    data = O ; 
                    disp(['Creating ',fullfile(BoerDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat'])]) ;
                    data(SurfPmat < Pmat) = 0 ;
                    try
                        save(fullfile(BoerDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat']),'bata') ;
                    catch
                        mkdir(fullfile(BoerDir,int2str(y),'')) ;
                        save(fullfile(BoerDir,int2str(y),[int2str(m*10000 + (d-1)*100 + (h-1)*3),'.mat']),'bata') ;
                    end
                    q = q + 1 ;
                catch
                    % No Such File
                end
            end
        end
    end
end
te = toc ;
H = floor(te/3600) ;
M = (te - H*3600)/60 ;
if q
disp(['BoerBeta field: ',BoerDir,'  -- completed in ',int2str(H),' hours and ',int2str(M),' minutes.'])
else
disp(['No BoerBeta files were created. Check reference field -- ',FieldDir])    
end