% GOAT2Code_Limits generate m code for the selected data, limits, settings, and filters
% Copyright (C) Ori Adam Aug.2013. compatible with version 2013i or later
% this function executes using the 'get m code' button in the Limits GUI
% cell-1: Initiate GOAT  and set Dataset, Field and temporal resolution
% cell-2: set temporal limits
% cell-3: set spatial limits and Filters/weights
% cell-4: retrieve and compile data
% cell-5: plot
% cell-6: save

function GOAT2Code_Limits(G)
c = clock ; 
TimeStamp = [date,'-',int2str(c(4)),':',int2str(c(5))] ;
mcode = cell(1,1) ; 
L = 1 ; 
mcode(L,1) = {' '                                                                          } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                          } ; L = L + 1 ; 
mcode(L,1) = {['% - - - code generated by GOAT2Code_Limits.m - ',TimeStamp,' - - - - - - ' ]                } ; L = L + 1 ; % Delimiter
mcode(L,1) = {' '                                                                          } ; L = L + 1 ; 
mcode(L,1) = {'% It is recommended though not mandatory to work from the ... GOAT/Code directory '} ; L = L + 1 ; 
mcode(L,1) = {'% When not working from the GOAT/Code directory make sure that the following directories '} ; L = L + 1 ; 
mcode(L,1) = {'% and all their subdirectories are added to the matlab path: '                       } ; L = L + 1 ; 
mcode(L,1) = {'% ... GOAT/Code,   GOAT/Scripts,   and GOAT/MyScripts '                     } ; L = L + 1 ; 
mcode(L,1) = {'% cell-1: Initiate GOAT and set: Dataset, Field and Calendar'    } ; L = L + 1 ; 
mcode(L,1) = {'% cell-2: Set temporal limits'                                              } ; L = L + 1 ; 
if G.ProjectionType == 10
mcode(L,1) = {'% cell-3: Install Linked Data'                                              } ; L = L + 1 ; 
else
mcode(L,1) = {'% cell-3: Set spatial limits and Filters/weights'                           } ; L = L + 1 ; 
mcode(L,1) = {'% cell-4: Retrieve and compile data'                                        } ; L = L + 1 ; 
mcode(L,1) = {'% cell-5: plot'                                                             } ; L = L + 1 ; 
mcode(L,1) = {'% cell-6: save'                                                             } ; L = L + 1 ; 
end
mcode(L,1) = {' '                                                                          } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                          } ; L = L + 1 ; 
%% cell-1
mcode(L,1) = {'%% cell-1: Initiate GOAT and set: Dataset, Field and Calendar '       } ; L = L + 1 ; 
mcode(L,1) = {'G = GOAT_Environment(''enter_project_path'') ; % Initiate GOAT Environment' } ; L = L + 1 ;
if strncmp(G.DataFolder,'..',2)
    G.DataFolder = [fileparts(cd),G.DataFolder(3:end)] ;
end
mcode(L,1) = {['G = GOAT_Initialize_Dataset(G,''',G.DataFolder,''',''',G.TimeFieldVirtual,''') ; % Go through contents of Data folder and Calendar. Link existing fields, temporal span, etc.' ]} ; L = L + 1 ;
mcode(L,1) = {['G = GOAT_Initialize_Field(G,''',G.DataField,''')        ; % get spatial and temporal dimensions of field, display settings, topography, and file addresses. Link if necessary' ]} ; L = L + 1 ;
if ~strcmpi(G.TimeField,'list')
mcode(L,1) = {['Year0 = ',int2str(G.Limits.Year0),' ; % first year of the field ',G.DataField]} ; L = L + 1 ; 
end
%% cell-2
mcode(L,1) = {'%% cell-2: Temporal limits'                                                        } ; L = L + 1 ;
mcode(L,1) = {'% Temporal Checkboxes/Flags'                                                        } ; L = L + 1 ;
mcode(L,1) = {['G.Limits.Default.Day2same   = ',int2str(G.Limits.Default.Day2same),' ; % 1/0 Set Date 2 same as Date 1']} ; L = L + 1 ; 
mcode(L,1) = {['G.Limits.Default.Sequential = ',int2str(G.Limits.Default.Sequential),' ; % 1/0 Sequential or Seasonal averaging Flag']                                   } ; L = L + 1 ; 
mcode(L,1) = {['G.Limits.Default.ClimatologyContinuous = ',int2str(G.Limits.Default.ClimatologyContinuous),' ; % present seasonal data sequentially in Hovmoller plots'] } ; L = L + 1 ; 
mcode(L,1) = {['G.Limits.Default.Anom  = ',int2str(G.Limits.Default.Anom),'      ; % display anomalies in Hovmoller plots']                                              } ; L = L + 1 ; 
if ~strcmpi(G.TimeField,'list') 
mcode(L,1) = {['year1  = ',int2str(G.Limits.years(G.Limits.Default.year1)),' ; % yyyy']          } ; L = L + 1 ;
if ~strncmpi(G.TimeFieldVirtual,'Julian',6)
mcode(L,1) = {['month1 = ',int2str(G.Limits.Default.month1),'    ; % 1:12']                      } ; L = L + 1 ;
else
mcode(L,1) = {['month1 = 0    ; % no months in Julian temporal resolution']                      } ; L = L + 1 ;    
end
mcode(L,1) = {['day1   = ',int2str(G.Limits.Default.day1),'    ; % 1:31 ']                        } ; L = L + 1 ;
[YYY,X] = GOAT_ParseTimeResolution(G.TimeFieldVirtual) ; 
if X
mcode(L,1) = {['hour1  = ',int2str(round((G.Limits.Default.H1-1)*24/X)),'    ; % 0:3:21']           } ; L = L + 1 ;
else
mcode(L,1) = {['hour1  = 0    ; % 0:3:21']           } ; L = L + 1 ;    
end
mcode(L,1) = {['year2  = ',int2str(G.Limits.years(G.Limits.Default.year2)),' ; ']           } ; L = L + 1 ;
if ~strncmpi(G.TimeFieldVirtual,'Julian',6)
mcode(L,1) = {['month2 = ',int2str(G.Limits.Default.month2),'    ; ']                       } ; L = L + 1 ;
else
mcode(L,1) = {['month2 = 0    ; % no months in Julian temporal resolution']                       } ; L = L + 1 ;    
end
mcode(L,1) = {['day2   = ',int2str(G.Limits.Default.day2),'    ; ']                         } ; L = L + 1 ;
if X
mcode(L,1) = {['hour2  = ',int2str(round((G.Limits.Default.H2-1)*24/X)),'    ; ']           } ; L = L + 1 ;
else
mcode(L,1) = {['hour2  = 0    ; ']           } ; L = L + 1 ;    
end
mcode(L,1) = {'% G.Limits.S1 and G.Limits.S1 are the temporal indices used by GOAT to locate files in the GOAT archiving standard' } ; L = L + 1 ;
mcode(L,1) = {'G.Limits.S1 = GOAT_getSerial(year1,month1,day1,hour1,G.TimeFieldVirtual,G.Limits.Year0) ; ' } ; L = L + 1 ;
mcode(L,1) = {'if G.Limits.Default.Day2same && G.Limits.Default.Sequential'                 } ; L = L + 1 ;
mcode(L,1) = {'    G.Limits.S2 = G.Limits.S1 ;'                                             } ; L = L + 1 ;
mcode(L,1) = {'else'                                                                        } ; L = L + 1 ;
mcode(L,1) = {'G.Limits.S2 = GOAT_getSerial(year2,month2,day2,hour2,G.TimeFieldVirtual,G.Limits.Year0) ; ' } ; L = L + 1 ;
mcode(L,1) = {'end '                                                                        } ; L = L + 1 ;
else
% instead of index, use folder name to find index
mcode(L,1) = {['ListFolder = ''',G.Addresses.Linears{G.Addresses.LinearIdx},'''    ; ']                       } ; L = L + 1 ;
mcode(L,1) = {['G.Addresses.LinearIdx = find(strcmp(G.Addresses.Linears,ListFolder))    ; ']              } ; L = L + 1 ;
mcode(L,1) = {['G = GOAT_List_Initialize(G) ; ']} ;    
mcode(L,1) = {['  G.Limits.S1 = ',int2str(G.Limits.Default.time1),' ; % sequential index in linear time from 1 to end'   ]} ; L = L + 1 ;
mcode(L,1) = {'  if G.Limits.Default.Day2same'                                              } ; L = L + 1 ;
mcode(L,1) = {'  G.Limits.S2 = G.Limits.S1 ; '                                              } ; L = L + 1 ;
mcode(L,1) = {'  else'                                                                      } ; L = L + 1 ;
mcode(L,1) = {['  G.Limits.S2 = ',int2str(G.Limits.Default.time2),' ;      '      ]         } ; L = L + 1 ;
mcode(L,1) = {'  end'                                                                       } ; L = L + 1 ;
end
if G.ProjectionType == 10 % Install Linked Data
mcode(L,1) = {'%% cell-3: Install Linked Data'                                              } ; L = L + 1 ;
mcode(L,1) = {['G.ProjectionType = ',int2str(G.ProjectionType),' ; % ']                     } ; L = L + 1 ;
G.ALP.Calendar = G.TimeFieldVirtual ;
G.ALP.OverWriteFlag  = 0 ;
G.ALP.BoerBetaFlag   = 0 ;
G.ALP.SaveSingle     = 0 ;
mcode(L,1) = {['G.ALP.ExportAddress  = ''',G.ALP.ExportAddress,''' ; % ']                     } ; L = L + 1 ;
mcode(L,1) = {['G.ALP.Calendar       = ''',G.ALP.Calendar,''' ; % Calendar']                     } ; L = L + 1 ;
mcode(L,1) = {['G.ALP.OverWriteFlag  = ',int2str(G.ALP.OverWriteFlag),' ; % when checked, data will NOT be overwritten']                     } ; L = L + 1 ;
mcode(L,1) = {['G.ALP.BoerBetaFlag   = ',int2str(G.ALP.BoerBetaFlag) ,' ; % create BoerBeta function']                     } ; L = L + 1 ;
mcode(L,1) = {['G.ALP.SaveSingle     = ',int2str(G.ALP.SaveSingle) ,' ; % save data as single precision']                     } ; L = L + 1 ;
mcode(L,1) = {['G = GOAT_ALP_Install(G) ; % Install as MAT archive format from OPeNDAP server or nc file ']                     } ; L = L + 1 ;
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
mcode(L,1) = {['% - - - code end - ',TimeStamp,' - - - - - - - ']                                                        } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
else
%% cell-3
mcode(L,1) = {'%% cell-3: Spatial limits'                                                           } ; L = L + 1 ;
mcode(L,1) = {'% Checkboxes/Flags'                                                           } ; L = L + 1 ;
mcode(L,1) = {['G.ProjectionType = ',int2str(G.ProjectionType),' ; % 1) lat-lon with coast 2) lat-lon 3) lat-height 4)lon-height 5) hovmoller-lon 6) hovmoller-lat 7) hovmoller height 8/9) NH/SH polar stereographic']} ; L = L + 1 ;
mcode(L,1) = {['G.Limits.Default.sameP = ',int2str(G.Limits.Default.sameP),'      ; % Projection 1,2,8,9) 1/0 set level2 = level1 | Projection 3,4,7) 1/0 composite levels'] } ; L = L + 1 ; 
mcode(L,1) = {['G.Limits.Default.VerMeanInt = ',int2str(G.Limits.Default.VerMeanInt),' ; % 1) Vertical Mean 2) Integral using Boer Beta 3) set Nan values to zero and vertically integrate']} ; L = L + 1 ; 
mcode(L,1) = {['G.Settings.NanMeanFlag = ',int2str(G.Settings.NanMeanFlag),'  ; % use mean(x) when 0 and nanmean(x) when 1']} ; L = L + 1 ; 
Plevel1 = G.lev(G.Limits.Default.Lev1)  ; 
Plevel2 = G.lev(G.Limits.Default.Lev2)  ; 
Lat1    = G.lat(G.Limits.Default.Lat1)  ; 
Lat2    = G.lat(G.Limits.Default.Lat2)  ; 
Lon1    = G.lon(G.Limits.Default.Lon1)  ; 
Lon2    = G.lon(G.Limits.Default.Lon2)  ; 
mcode(L,1) = {['Level1  = ',num2str(Plevel1),' ; % GOAT will use the nearest level to this value']                                         } ; L = L + 1 ;
mcode(L,1) = {['Level2  = ',num2str(Plevel2),' ; % GOAT will use the nearest level to this value']                                         } ; L = L + 1 ;
mcode(L,1) = {['Lon1    = ',num2str(Lon1),'   ; % use values from -360 to 360. GOAT will use the nearest values to the ones specified']                                          } ; L = L + 1 ;
mcode(L,1) = {['Lon2    = ',num2str(Lon2),'   ; % use values from -360 to 360. ']                                          } ; L = L + 1 ;
mcode(L,1) = {['Lat1    = ',num2str(Lat1),'   ; % use values from -90 to 90. GOAT will use the nearest values to the ones specified.']                                          } ; L = L + 1 ;
mcode(L,1) = {['Lat2    = ',num2str(Lat2),'   ; % Lat2 does not have to be larger than Lat1.']                                          } ; L = L + 1 ;
mcode(L,1) = {'G.Limits.Default.Lev1 = dsearchn(double(G.lev),Level1) ; '                    } ; L = L + 1 ; 
mcode(L,1) = {'G.Limits.Default.Lev2 = dsearchn(double(G.lev),Level2) ; '                    } ; L = L + 1 ; 
mcode(L,1) = {'G.Limits.Default.Lat1 = dsearchn(G.lat,Lat1)  ; '                            } ; L = L + 1 ; 
mcode(L,1) = {'G.Limits.Default.Lat2 = dsearchn(G.lat,Lat2)  ; '                            } ; L = L + 1 ; 
mcode(L,1) = {'G.Limits.Default.Lon1 = dsearchn(G.lon,Lon1)  ; '                            } ; L = L + 1 ; 
mcode(L,1) = {'G.Limits.Default.Lon2 = dsearchn(G.lon,Lon2)  ; '                            } ; L = L + 1 ; 
mcode(L,1) = {'% Filters, Weights and Indices: '                                                                   } ; L = L + 1 ; 
if G.Filter.WeightIdx          ~= 1 || ...
        sum(G.Filter.ZonalWaveNumberIdx) > -1 || ...
        G.Filter.RAIdx              ~= 1 || ...
        G.Filter.LowPassIdx         ~= 0 || ...
        G.Filter.HighPassIdx        ~= 0 || ...
        G.Filter.IndicesIdx         ~= 1 || ...
        G.Filter.ZEFlag
% Index 
if G.Filter.IndicesIdx  > 1 ; 
mcode(L,1) = {['load(G.Filter.IndexAddress) ; ']                                                                        } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.Index = Index      ; ']                                                                        } ; L = L + 1 ; 
else
mcode(L,1) = {['G.Filter.Index = ones(length(G.Addresses.Default),1) ;']                                                } ; L = L + 1 ; 
end
mcode(L,1) = {['G.Filter.WeightIdx = ',int2str(G.Filter.WeightIdx),' ; % 1 = None']                                     } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.ZonalWaveNumberIdx = [',int2str(G.Filter.ZonalWaveNumberIdx),'] ; % 0 = no Filter']              } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.ZonalWaveNumberLowIdx  = [',int2str(G.Filter.ZonalWaveNumberLowIdx),'] ; % Low zonal wave number truncation (1= none)']    } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.ZonalWaveNumberHighIdx = [',int2str(G.Filter.ZonalWaveNumberHighIdx),'] ; % High zonal wave number truncation (1 = none)'] } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.RAIdx              = ',int2str(G.Filter.RAIdx),'     ; % 0 = no Filter']                     } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.REFlag             = ',int2str(G.Filter.REFlag),'     ; % No Running Eddy']                  } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.LowPassIdx         = ',int2str(G.Filter.LowPassIdx),'     ; % 0 = no lowpass Filter value']  } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.HighPassIdx        = ',int2str(G.Filter.HighPassIdx),'     ; % 0 = no highpass Filter value']} ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.ZEFlag             = ',int2str(G.Filter.ZEFlag),'     ; % Zonal Anomaly Flag']               } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.WeightFactor       = ',num2str(G.Filter.WeightFactor),'     ; % Weight factor value']        } ; L = L + 1 ; 
else
mcode(L,1) = {['% No Filters, Weights or Indices Selected ']                                                            } ; L = L + 1 ; 
mcode(L,1) = {['G.Filter.Index = ones(length(G.Addresses.Default),1) ; % default index']                                } ; L = L + 1 ; 
end
%% cell-4
mcode(L,1) = {['%% cell-4: retrieve and compile data ']                                                                          } ; L = L + 1 ;
%mcode(L,1) = {'% calculate Time Series and Composite  '                                                                          } ; L = L + 1 ; 
mcode(L,1) = {['G = GOAT_Compile_data_Series(G) ; ']                                                                          } ; L = L + 1 ; 
mcode(L,1) = {['Data  = G.Data            ; % Composited data ']                                                                     } ; L = L + 1 ; 
mcode(L,1) = {['DataSeries = G.DataSeries ; % Time Series '                                ]    } ; L = L + 1 ; 
mcode(L,1) = {['Dates = G.FilteredDates   ; % Time Series Dates ']                                                                     } ; L = L + 1 ; 
mcode(L,1) = {['x = G.x ; y = G.y         ; % x and y vectors'                           ]         } ; L = L + 1 ; 
mcode(L,1) = {['X = G.X ; Y = G.Y         ; % meshed x and y vectors. Use contourf(X,Y,Data'') to plot data.'                           ]         } ; L = L + 1 ; 
mcode(L,1) = {'%% Optional: obtain time series and time mean of 3D data '                                                             } ; L = L + 1 ; 
mcode(L,1) = {['% G = GOAT_Compile_data_3D(G) ; % obtain spatially truncated (but not projected) 3D timeseries. Spatial and temporal filters can be applied. ']                                                                          } ; L = L + 1 ; 
mcode(L,1) = {['% G = GOAT_Compile_bata_3D(G) ; % obtain spatially truncated (but not projected) 3D timeseries of the BoerBeta function (when relevant)']                                                                          } ; L = L + 1 ; 
mcode(L,1) = {['% Bata  = G.Bata   ; BataSeries = G.BataSeries ; % Mean and Time Series of the BoerBeta function'                                ]    } ; L = L + 1 ; 
mcode(L,1) = {'%% Optional: calculate climatology and anomaly (from climatology)'                                                             } ; L = L + 1 ; 
mcode(L,1) = {['% G.Limits.Default.DataClimSmooth = ',int2str(G.Limits.Default.DataClimSmooth),' ; % Smooth climatology using a centered running mean (G.Limits.Default.DataClimSmooth = 3 5 7 ...). 1 = ''none''']} ; L = L + 1 ; 
mcode(L,1) = {'% G = GOAT_Compile_Climatology(G)     ; % calculate climatology (monthly, daily or diurnal) from time series'} ; L = L + 1 ;
mcode(L,1) = {'% DataClim       = G.DataClim         ; % Climatology field derived from the time series'                                } ; L = L + 1 ; 
mcode(L,1) = {'% G = GOAT_Compile_ClimAnomaly(G)     ; % Anomaly derived from Climatology (monthly, daily or diurnal)'} ; L = L + 1 ;
mcode(L,1) = {'% DataSeriesAnom = G.DataSeriesAnom   ; % time series of the anomaly from climatology'  } ; L = L + 1 ; 

%% cell-5
mcode(L,1) = {'%% cell-5: plot Right Hand Side and ''Settings'' Plot Settings'                                             } ; L = L + 1 ;
mcode(L,1) = {'% Right Hand Side and ''Settings'' Plot Settings'                                             } ; L = L + 1 ;
%mcode(L,1) = {'G.Plotting.GUI_PlotFlag = 0              ; % Informs GOAT_plotUpdate that the plotting is not in GUI format'   } ; L = L + 1 ; 
mcode(L,1) = {['G.Settings.ContourIdx        = ',int2str(G.Settings.ContourIdx),'        ; % Contour Type Idx']          } ; L = L + 1 ;
mcode(L,1) = {['colormapName = ''',G.Settings.ColorMap{G.Settings.ColorMapIdx},'''      ; % ColorMap Name as it appears in the GUI']    } ; L = L + 1 ;
mcode(L,1) = {['G.Settings.ColorMapIdx = find(strcmp(G.Settings.ColorMap,colormapName))  ; % actual colormap is found in G.Settings.ColorMaps.colormapName']    } ; L = L + 1 ;
mcode(L,1) = {['G.Settings.ReverseColorMap   = ',int2str(G.Settings.ReverseColorMap),'   ; % 0/1 Reverse Colormap checkbox']         } ; L = L + 1 ;
%mcode(L,1) = {['G.Settings.CoastLineWidthIdx = ',int2str(G.Settings.CoastLineWidthIdx),' ; % Default LineWidth Index in Plots']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.CoastLineWidth    = ',num2str((G.Settings.CoastLineWidthIdx-1)/2),' ; % 0 | .5 | 1  ...']                          } ; L = L + 1 ; 
mcode(L,1) = {['G.Settings.XgridFlag         = ',int2str(G.Settings.XgridFlag),'         ; % A flag for displaying the X Grid Lines']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.YgridFlag         = ',int2str(G.Settings.YgridFlag),'         ; % A flag for displaying the Y Grid Lines']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.SymZLimitsFlag    = ',int2str(G.Settings.SymZLimitsFlag),'    ; % A flag for setting limits symmetric with respect to zero (good for divergent colormaps)']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.FixZLimitsFlag    = ',int2str(G.Settings.FixZLimitsFlag),'    ; % A flag for fixing limits (useful in auto time steps)']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.LogLevelsFlag     = ',int2str(G.Settings.LogLevelsFlag) ,'    ; % log(P) in lat-P,Lon-P projections']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.SinLatFlag        = ',int2str(G.Settings.SinLatFlag)    ,'    ; % plot sin(latitude) in projections involving latitude']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.ContourLevelStep  = ',num2str(G.Settings.ContourLevelStep),'  ; % contour step. 0 = auto']    } ; L = L + 1 ;
%mcode(L,1) = {['G.Settings.LineWidthIdx      = ',int2str(G.Settings.LineWidthIdx),'      ; % Default LineWidth Index in Plots']} ; L = L + 1 ;
mcode(L,1) = {['G.Settings.LineWidth         = ',num2str((G.Settings.LineWidthIdx-2)/2),' ; % Darken_Edge | None | .5 | 1 | 1.5 ...']                            } ; L = L + 1 ;
mcode(L,1) = {['G.topo.TypeFlag              = ',num2str(G.topo.TypeFlag),' ; % 1=None | 2=Atmo | 3=Ocean | 4=Atmo+Ocean']                          } ; L = L + 1 ; 
if any(G.ProjectionType == [1,2])
mcode(L,1) = {['G.topo.interval = ',num2str(G.topo.interval),' ; ']                                                      } ; L = L + 1 ; 
mcode(L,1) = {'switch G.topo.TypeFlag'                                                                                   } ; L = L + 1 ; 
mcode(L,1) = {['  case {1,2}'                                                                                           ]} ; L = L + 1 ;  
mcode(L,1) = {['  G.topo.intervalmin = 0     ;  '                                                                       ]} ; L = L + 1 ;  
mcode(L,1) = {['  G.topo.intervalmax = 8000  ;  '                                                                       ]} ; L = L + 1 ;
mcode(L,1) = {['  case 3 '                                                                                              ]} ; L = L + 1 ;
mcode(L,1) = {['  G.topo.intervalmin = -8000 ; '                                                                        ]} ; L = L + 1 ;
mcode(L,1) = {['  G.topo.intervalmax =  0    ; '                                                                        ]} ; L = L + 1 ;
mcode(L,1) = {['  case 4'                                                                                               ]} ; L = L + 1 ;
mcode(L,1) = {['  G.topo.intervalmin = -8000 ; '                                                                        ]} ; L = L + 1 ; 
mcode(L,1) = {['  G.topo.intervalmax = 8000  ; '                                                                        ]} ; L = L + 1 ;   
mcode(L,1) = {['end '                                                                                                   ]} ; L = L + 1 ;
mcode(L,1) = {['G.topo.topovec = G.topo.intervalmin:G.topo.interval:G.topo.intervalmax ; '                              ]} ; L = L + 1 ;
mcode(L,1) = {['zeroidx = dsearchn(G.topo.topovec'',0) ; '                                                              ]} ; L = L + 1 ; 
mcode(L,1) = {['G.topo.topovec = G.topo.topovec(G.topo.topovec~=G.topo.topovec(zeroidx))  ;                    '        ]} ; L = L + 1 ;
mcode(L,1) = {['G.topo.TopotLineWidthIdx = ',int2str(G.topo.TopotLineWidthIdx),' ; % 0.5 | 1 | 1.5 | 2 | 2.5 ... '      ]} ; L = L + 1 ;
end
mcode(L,1) = {'% Create Figure and Plot'     } ; L = L + 1 ; 
mcode(L,1) = {'Fig = figure(''position'',G.GUI.pos.Main)  ; % create a figure with the same size as the GOAT figure'     } ; L = L + 1 ; 
mcode(L,1) = {'set(0,''CurrentFigure'',Fig)               ; % make sure it prints on new Fig'                            } ; L = L + 1 ; 
mcode(L,1) = {'G = GOAT_plotUpdate(G)                         ; % Plot without GUI features'                                 } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
%% cell-6
mcode(L,1) = {'%% cell-6: Save  '                                                                                        } ; L = L + 1 ; 
mcode(L,1) = {'if strcmp(G.GOAT_Directory,cd) % If working from . . . GOAT/Code'                                         } ; L = L + 1 ;
mcode(L,1) = {'    ExportFolder = fullfile(''..'',''Export'','''') ; '                                                   } ; L = L + 1 ;
mcode(L,1) = {'else'                                                                                                     } ; L = L + 1 ;
mcode(L,1) = {'    ExportFolder = ''Export'' ; mkdir(ExportFolder) ;  '                                                  } ; L = L + 1 ;
mcode(L,1) = {'end'                                                                                                      } ; L = L + 1 ;
mcode(L,1) = {['set(gcf,''PaperPositionMode'',''auto'',''papersize'',[',int2str(G.Saving.PapersizeGUI),'])  ; ']         } ; L = L + 1 ; 
mcode(L,1) = {['print(''-dpdf'',''-r70'',fullfile(ExportFolder,''SavedFigure'','''')) ; '                               ]} ; L = L + 1 ; 
mcode(L,1) = {'save(fullfile(ExportFolder,''SavedFigure.fig''),''Fig'') '                                                } ; L = L + 1 ; 
mcode(L,1) = {'save(fullfile(ExportFolder,''SavedData.mat''),''Data'') ;'                                                 } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
mcode(L,1) = {['% - - - code end - ',TimeStamp,' - - - - - - - ']                                                        } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
mcode(L,1) = {' '                                                                                                        } ; L = L + 1 ; 
end
disp(char(mcode));
try
    FileName = fullfile(fileparts(fileparts(which('GOAT.m'))),'Export','Untitled_GOAT_Code.m') ;
    if exist(FileName,'file')
        FileName = [FileName(1:end-2),'1.m'] ;
        %delete(FileName) ;
    end
    for j = 1:100
        if exist(FileName,'file')
            [FilePath,Name,Ext] = fileparts(FileName) ; 
            Name = regexprep(Name,int2str(j),int2str(j+1));
            FileName = fullfile(FilePath,[Name,Ext]) ; 
        else
            if j > 50
            disp(['!!!   Please clean up Auto GOAT Codes from ',fileparts(FileName)]) ;  
            end
            break 
        end
    end
    GOAT_cell2txt(FileName,mcode(3:end-4)) ;
    edit(FileName)
catch
    % Nevermind, Copy paste
end