% GOAT_DailyIndex2Monthly Convert Daily Index To Monthly
% Copyright (C) Ori Adam Dec.2012
%
% see also GOAT_MonthyIndex2Daily

[Fid, Fidf] = uigetfile ; 

load([Fidf,Fid]) ; % Load Index

[Path, Name, Ext] = fileparts([Fidf,Fid]) ; 

year1 = 1800  ; year2 = 2200 ; 

MonthlyIndex = zeros(20000,1) ;
q = 0 ; 
M = 800 ; 
for y = year1: year2
    for m = 1:12
        M = M + 1 ; 
        if y>2200
            MonthlyIndex(M) = 0  ; 
        else    
        switch m
            case {1,3,5,7,8,10,12}
                d = 31 ; 
                MonthlyIndex(M) = round(mean(Index(q+1:q+d))) ; 
                q = q + d ; 
            case {4,6,9,11}
                d = 30 ; 
                MonthlyIndex(M) = round(mean(Index(q+1:q+d))) ; 
                q = q + d ; 
            case 2
                if GOAT_leapyear(y)
                    d = 29 ; 
                else
                    d = 28 ; 
                end
                MonthlyIndex(M) = round(mean(Index(q+1:q+d))) ; 
                q = q + d ; 
        end
        end
    end
end

Index = MonthlyIndex(1:M) ;

save(fullfile(Path,[Name,'_Monthly.mat']),'Index') ; 
