% GOAT_DaysInMonth gives the number of days in a month for GOAT standard calendars.
% Copyright (C) Ori Adam, March.20.2014
% syntax:
% >> mdays = GOAT_DaysInMonth(m,y,Calendar)
%

function mdays = GOAT_DaysInMonth(m,y,Calendar)
if nargin > 3
    if strncmpi(Calendar,'Daily360',8)
        mdays = 30 ;
        return ;
    elseif strncmpi(Calendar,'Julian',6) || strncmpi(Calendar,'List',4)
        mdays = 0 ;
        return ;
    end
end
% Daily, Daily365, DailyXXX, Daily365XXX Calendars
switch m
    case {1,3,5,7,8,10,12}
        mdays = 31 ;
    case {4,6,9,11}
        mdays = 30 ;
    case 2
        switch nargin
            case 1
                mdays = 28 ;
            case 2
                if GOAT_leapyear(y)
                    mdays = 29 ;
                else
                    mdays = 28 ;
                end
            case 3
                if GOAT_leapyear(y,Calendar)
                    mdays = 29 ;
                else
                    mdays = 28 ;
                end
        end
end
