% GOAT_Hold_Data
% 'hold' present Data and Plot Settings =  store data in G.Hold
% syntax:
% >> G = GOAT_Hold_Data(G)
%

function G = GOAT_Hold_Data(G)

try
    G.Hold.infoMessage = dateMessage(G)                              ;
catch
    G.Hold.infoMessage = G.message                                   ;
end
try
    G.Hold.Units       = G.DataFieldUnits                            ;
    G.Hold.Description = G.FieldDescription                          ;
end
try  G.Hold.DataSeries      = single(G.DataSeries)                   ; end
try  G.Hold.DataClim        = G.DataClim                             ; end
try  G.Hold.DataSeriesAnom  = single(G.DataSeriesAnom)               ; end

try
G.Hold.Clim = get(gca,'CLim')                                        ;
end
try
G.Hold.colorbarLimits = G.Display.colorbarLimits                     ;
G.Hold.colorbarHandle = G.Display.colorbarHandle                     ;
end

Namelist = {'Data','X','x','y','Y','xlabel','ylabel','datalabel','Dates','FilteredDates','Filter','Limits.Default.sameP','Limits.Default.VerMeanInt','lon', ...
    'lat','P','lonlabel','latlabel','Plabel','Limits.Default.Lat1','Limits.Default.Lat2','Limits.Default.Lon1','Limits.Default.Lon2','Limits.Default.P1','Limits.Default.P2', ... 
    'Settings.ColorMapIdx','Settings.CoastLineWidthIdx','Settings.XgridFlag','Settings.YgridFlag','Settings.SymZLimitsFlag','Settings.FixZLimitsFlag','Settings.LogLevelsFlag','Settings.ContourLevelStep', ... 
    'Settings.ReverseColorMap','Settings.LineWidthIdx','Settings.LineWidth','Settings.CoastLineWidth','topo.TypeFlag','Settings.SinLatFlag'} ;

for j = 1:length(Namelist)
    try
    G.Hold.(Namelist{j}) = G.(Namelist{j}) ; 
    end
end