% GOAT_leapyear  returns a vector of ones or zeros, the same length as years, indictating which years are leap years
% syntax:
% >> ly = GOAT_leapyear(years,Calendar) ; % performs calculation if leap-years exist in Calendar 
% or
% >> ly = GOAT_leapyear(years) ;  % assumes a Gregorian calendar
% copyright(c) Ori Adam, Oct.2013 
%
% see also, GOAT_isGregorian

function ly = GOAT_leapyear(years,Calendar)
if nargin > 1 && ~GOAT_is_Gregorian(Calendar)
    ly = years*0 ;
else
    ly = double( ~(mod(years,4)) - ~(mod(years,100)) + ~(mod(years,100)+mod(years,400)) ) ;
end

% for k = 1:length(years)
%  if mod(years(k),100) == 0  % if divisible by 100
%    if mod(years(k),400) == 0  % if divisible by 400
%      ly(k) = 1 ;
%    end
%  elseif mod(years(k),4) == 0 % if divisible by 4
%        ly(k) = 1 ;
%  end
% end


