% GOAT_meanw weighted mean
% Copyright (C) Ori Adam Dec.2013
%
% syntax:
% >> output = GOAT_meanw(variable_to_average,weight,dimension)
%for example, gaussian grid averaging: zwind = GOAT_meanw(u(:,:),cosfi,2)  with u(longitude,latitude)


function output = GOAT_meanw(variable_to_average,weight,dimension)
if nargin<3
    dimension = 1 ; 
end
if nargin<2
    output = mean(variable_to_average) ;
    return ; 
else
    output = mean(variable_to_average.*weight,dimension)./mean(weight,dimension) ;
end

return ;

