% GOAT_serial2date retreive date from serial address
% Copyright (C) Ori Adam Jan.2012.
% syntax:
% >>   [year,month,day,hour] = GOAT_serial2date(Address_vec,Index)  % Address_vec is an address cell array such as G.Addresses.Default. Index is an integer or a vector of indices
%
% see also GOAT_Data_string_vec, GOAT_getSerial

function [year,month,day,hour] = GOAT_serial2date(string_vec,S)
[path,name] = fileparts(string_vec{S}) ;
year   = str2double(path)           ;
DayNum = str2double(name)           ;
if strncmpi(string_vec(end),'Julian',6) % Julian Days
    month = 0                 ;
    day   = floor(DayNum/100) ;
    hour   = DayNum - day*100 ;
else % Gregorian
    month  = floor(DayNum/10000)               ;
    day    = floor((DayNum - month*10000)/100) ;
    hour   = DayNum - month*10000 - day*100    ;
end
