% convert data string vec to cell vector of date strings in the format 'dateformat'. 
% Copyright (C) Ori Adam Aug.2013. compatible with version 2013i or later
% syntax: Datestrvec = datastringvec2date(datastringvec,dateformat)
% Datestrvec is a cell vector
% available formats:
% 'linear'
% 'mmm'
% 'mmm.dd'
% 'yy.mmm'
% 'yy.mmm.dd'
% 'yy.mm.dd'
% 'yyyy.mmm.dd'
% 'yyyy.mm.dd'
% 'yyyy.ddd' - Julian
% see also datastring2date, GOAT_serial2date

function Datestrvec = datastringvec2date(datastringvec,dateformat)
Datestrvec = cell(length(datastringvec),1) ; 
for i = 1: length(datastringvec)
   Datestrvec(i) = {datastring2date(datastringvec(i),dateformat)};
end

