% Load data exported by GOAT

function G = GOAT_Script_LoadExport(G)
% Copyright (C) Ori Adam Nov.2012. compatible with version 2013i and onwards
try
[Fid, Fidf] = uigetfile(fullfile('..','Export','*.mat')) ;
catch
[Fid, Fidf] = uigetfile(fullfile('..','*.mat')) ;    
end
if Fid == 0
    return
else
    load([Fidf,Fid]) ; 
end
G.Data = D.data                                                 ;
G.X    = D.X                                                    ;
G.x    = D.x                                                    ;
G.Y    = D.Y                                                    ;
G.y    = D.y                                                    ;
G.xlabel      = D.xlabel                                        ;
G.ylabel      = D.ylabel                                        ;
G.Datalabel   = D.datalabel                                     ;
G.Dates       = D.Dates                                         ;
G.ProjectionType = D.ProjectionType                             ;
try
G.Limits.Default.sameP = D.Limits.Default.sameP                 ;
catch
    % Nevermind ; 
end
try
set(G.h_Projection,'Value',G.ProjectionType) ;
end
G.lon         = D.lon                                           ;
G.lat         = D.lat                                           ;
G.P           = D.P                                             ;
try
G.lonlabel    = D.lonlabel                                      ;
G.latlabel    = D.latlabel                                      ;
G.Plabel      = D.Plabel                                        ;
catch
G.lonlabel    = 'Longitude'                                     ;
G.latlabel    = 'Latitude'                                      ;
G.Plabel      = 'Level'                                         ;    
end
G.Limits.Default.Lat1 = D.Limits.Default.Lat1                   ;
G.Limits.Default.Lat2 = D.Limits.Default.Lat2                   ;
G.Limits.Default.Lon1 = D.Limits.Default.Lon1                   ;
G.Limits.Default.Lon2 = D.Limits.Default.Lon2                   ;
G.Limits.Default.Lev1 = D.Limits.Default.Lev1                   ;
G.Limits.Default.Lev2 = D.Limits.Default.Lev2                   ;
                    
GOAT_plotUpdate(G)        ; % Update Display
set(G.h_message,'string',D.infoMessage) ; % Update Message